import math ,os ,time #line:1
import c4d #line:2
from cams_utils_c4d_version import *#line:3
from cams_utils_dialog import *#line:4
from cams_ids import *#line:5
from cams_ids_dialogs import *#line:6
from cams_utils_image import *#line:7
from cams_utils_pref import *#line:8
from cams_utils import *#line:9
from cams_utils_commands import *#line:10
from cams_deferred_render import DeferredRendering #line:11
from cams_dialog_about import DialogAbout #line:12
from cams_dialog_popup_design import PopupDesignIcons ,DialogPopupDesign #line:13
from cams_dialog_popup_per_camera import PopupPerCameraIcons ,DialogPopupPerCamera #line:14
from cams_dialog_popup_command_panel import PopupCommandPanelIcons ,DialogPopupCommandPanel #line:15
class DialogMainCams (c4d .gui .GeDialog ):#line:21
    _quickTabCameras =None #line:22
    _bitmapButtonDesignPopup =None #line:23
    _bitmapButtonCommandPanel =None #line:24
    _dlgPopup =None #line:26
    _iconsPopupPerCamera =None #line:27
    _dlgPopupCommandPanel =None #line:28
    _iconsPopupCommandPanel =None #line:29
    _dlgPopupDesign =None #line:30
    _iconsPopupDesign =None #line:31
    _bmpThumbRenderBusy =None #line:33
    _bmpActiveCamera =None #line:34
    _bmpActiveCameraSmall =None #line:35
    _bmpEditorCamera =None #line:36
    _bmpEditorCameraSmall =None #line:37
    _bmpCommandPanel =None #line:39
    _bmpCommandPanelRenderBusy =None #line:40
    _bcWeights =None #line:42
    _cameraAttributes =None #line:43
    _listDocs =[]#line:45
    _deferredRenderer =None #line:46
    _bmpsProofSheet ={}#line:48
    _timeLastClick =MyTime ()#line:50
    _idxCamLastClick =None #line:51
    _dlgPopup =None #line:53
    def __init__ (OOOOO0000OO00OOOO ):#line:55
        OOOOO0000OO00OOOO ._quickTabCameras =None #line:56
        OOOOO0000OO00OOOO ._bitmapButtonDesignPopup =None #line:57
        OOOOO0000OO00OOOO ._bitmapButtonCommandPanel =None #line:58
        OOOOO0000OO00OOOO ._iconsPopupPerCamera =PopupPerCameraIcons ()#line:60
        OOOOO0000OO00OOOO ._iconsPopupCommandPanel =PopupCommandPanelIcons ()#line:61
        OOOOO0000OO00OOOO ._iconsPopupDesign =PopupDesignIcons ()#line:62
        OOOOO0000OO00OOOO .InitCommandPanelButtonIcons ()#line:64
        OOOOO0000OO00OOOO .InitThumbRenderBusy ()#line:65
        OOOOO0000OO00OOOO .InitActiveCameraLabel ()#line:66
        OOOOO0000OO00OOOO .InitEditorCameraLabel ()#line:67
        OOOOO0000OO00OOOO ._cameraAttributes =None #line:69
        OOOOO0000OO00OOOO ._listDocs =[]#line:71
        OOOOO0000OO00OOOO ._deferredRenderer =DeferredRendering (PLUGIN_ID_CAMS_COREMESSAGE ,SUBID_COREMESSAGE_RENDER_FINISHED_DLG_MAIN ,SUBID_COREMESSAGE_CAMERA_LIST_CHANGE )#line:74
        OOOOO0000OO00OOOO ._bmpsProofSheet ={}#line:76
        OOOOO0000OO00OOOO ._timeLastClick =MyTime ()#line:78
        OOOOO0000OO00OOOO ._dlgPopup =None #line:80
        c4d .gui .GeDialog .__init__ (OOOOO0000OO00OOOO )#line:82
    def InitCommandPanelButtonIcons (OOO0OOOO000OO000O ):#line:85
        OOO0OOOO000OO000O ._bmpCommandPanel =LoadImage ('icon',guiPixelRatio =2.0 ,factor =0.5 )#line:86
        OOO0OOOO000OO000O ._bmpCommandPanelRenderBusy =LoadImage ('icon_render_busy',guiPixelRatio =2.0 ,factor =0.5 )#line:87
    def InitThumbRenderBusy (O000OO000OO0000OO ):#line:89
        O000OO000OO0000OO ._bmpThumbRenderBusy =GetIconImage (ID_ICON_RENDER_BUSY )#line:90
    def InitActiveCameraLabel (O0OOOO0O0OOOO00O0 ,subfolder ='img'):#line:93
        if CheckRessourceImage ('active_camera',subfolder =subfolder ):#line:94
            O0OOOO0O0OOOO00O0 ._bmpActiveCamera =LoadImage ('active_camera',subfolder =subfolder )#line:95
        else :#line:97
            O0OOOO0O0OOOO00O0 ._bmpActiveCamera =GetIconImage (c4d .RESOURCEIMAGE_OBJECTMANAGER_STATE4 )#line:98
        if CheckRessourceImage ('active_camera_small',subfolder =subfolder ):#line:100
            O0OOOO0O0OOOO00O0 ._bmpActiveCameraSmall =LoadImage ('active_camera_small',subfolder =subfolder )#line:101
        else :#line:103
            O0OOOO0O0OOOO00O0 ._bmpActiveCameraSmall =GetIconImage (c4d .RESOURCEIMAGE_OBJECTMANAGER_STATE4 ,factor =0.5 )#line:104
    def InitEditorCameraLabel (OOOOOO0000O0O0O0O ,subfolder ='img'):#line:107
        OOOOOO0000O0O0O0O ._bmpEditorCamera =LoadImage ('editor_camera',subfolder =subfolder )#line:108
        OOOOOO0000O0O0O0O ._bmpEditorCameraSmall =LoadImage ('editor_camera_small',subfolder =subfolder )#line:109
    def ShowPopupDialog (OO00000O0O0O0O0O0 ,O00OOOOO0O0O00000 ,OOO0O00OO0000OOOO ,OO0O00OO0O000OO0O ,OO0OOO00000O0000O ,cd =None ,x =-1 ,y =-1 ):#line:112
        if OO00000O0O0O0O0O0 ._dlgPopup is not None :#line:113
            OO00000O0O0O0O0O0 ._dlgPopup .Close ()#line:114
            OO00000O0O0O0O0O0 ._dlgPopup =None #line:115
        OO00000O0O0O0O0O0 ._dlgPopup =DialogPopupPerCamera (OO00000O0O0O0O0O0 ._iconsPopupPerCamera ,O00OOOOO0O0O00000 ,OOO0O00OO0000OOOO ,OO0O00OO0O000OO0O ,OO0OOO00000O0000O ,(OO00000O0O0O0O0O0 ._flagsTimerReason &0x02 )==0x02 )#line:117
        x ,y =AtMousePointer (OO00000O0O0O0O0O0 ,x ,y )#line:119
        OO00000O0O0O0O0O0 ._dlgPopup .Open (dlgtype =c4d .DLG_TYPE_ASYNC_POPUPEDIT ,pluginid =0 ,xpos =x ,ypos =y ,defaultw =0 ,defaulth =0 ,subid =0 )#line:121
    def ScaleThumb (O0O0O0OOOO0O0O00O ,O000000O0OO0O0O00 ):#line:124
        if O000000O0OO0O0O00 is None :#line:125
            return None #line:126
        O0OOOOO00000OOO00 =ReadPrefValue (ID_PREF_THUMB_SIZE )#line:128
        OO0OO0O00OOOOOOO0 ,OOOO0O00OOOO000O0 =O000000O0OO0O0O00 .GetSize ()#line:130
        if OO0OO0O00OOOOOOO0 <10 or OOOO0O00OOOO000O0 <10 :#line:131
            return None #line:132
        OO0OOO0OO00O00O0O =max (OO0OO0O00OOOOOOO0 ,OOOO0O00OOOO000O0 )#line:134
        O000OOO0O0OOO0OO0 =float (THUMB_RESOLUTIONS [O0OOOOO00000OOO00 ][0 ])/float (OO0OOO0OO00O00O0O )#line:136
        O0O0O0OOO0O0OO000 =int (O000OOO0O0OOO0OO0 *float (OO0OO0O00OOOOOOO0 ))#line:138
        OOO00OO0O0O0OO0OO =int (O000OOO0O0OOO0OO0 *float (OOOO0O00OOOO000O0 ))#line:139
        if O000000O0OO0O0O00 .IsMultipassBitmap ():#line:141
            OOO000O00OO00OOOO =c4d .bitmaps .MultipassBitmap (O0O0O0OOO0O0OO000 ,OOO00OO0O0O0OO0OO ,c4d .COLORMODE_ARGB )#line:142
            if O000000O0OO0O0O00 .GetInternalChannel ()is not None :#line:143
                OOO000O00OO00OOOO .AddChannel (True ,False )#line:144
        else :#line:146
            OOO000O00OO00OOOO =c4d .bitmaps .BaseBitmap ()#line:147
            OOO000O00OO00OOOO .Init (O0O0O0OOO0O0OO000 ,OOO00OO0O0O0OO0OO )#line:148
        O000000O0OO0O0O00 .ScaleIt (OOO000O00OO00OOOO ,256 ,True ,False )#line:150
        return OOO000O00OO00OOOO #line:152
    def ThumbHeightMax (OO0OO00OO000O00OO ,OOOOO0O0OOOO0O000 ,O0OO000O0OO00OOOO ):#line:155
        O0OOO00OO00OOOO00 =0 #line:156
        for OOO0O00OO0OO0OO00 in OOOOO0O0OOOO0O000 .values ():#line:158
            if OOO0O00OO0OO0OO00 is None :#line:159
                continue #line:160
            OO0O000O000O00OO0 ,O0OOOO0O0OOO000O0 =OOO0O00OO0OO0OO00 .GetSize ()#line:162
            O0OOO00OO00OOOO00 =max (O0OOOO0O0OOO000O0 ,O0OOO00OO00OOOO00 )#line:163
        if O0OOO00OO00OOOO00 ==0 :#line:165
            O0OOO00OO00OOOO00 =O0OO000O0OO00OOOO #line:166
        return O0OOO00OO00OOOO00 #line:168
    def DrawActiveMarker (OO0OO0O0O000OOOOO ,O0O0000OO000OO00O ,O00O0OO0OO0O00000 ,OOO0O00OO0O0OO000 ,O0OOOO000OOO0O0OO ,OOO0OOOO0OOO0O000 ):#line:171
        if (OOO0O00OO0O0OO000 &0x0F )==0 :#line:172
            return #line:173
        OOO0O0O0O00OO0O00 =GetPrefThumbMarkerImage ()#line:175
        if OOO0O0O0O00OO0O00 is None :#line:176
            PrintError ('No marker image!')#line:177
            return #line:178
        O0OOOOOOO0OOO0OO0 =O0O0000OO000OO00O .GetInternalChannel ()#line:180
        OO0OO0OO00O00000O =OOO0O0O0O00OO0O00 .GetInternalChannel ()#line:181
        OOOOOO0OOOOO00OO0 ,OOO00O0O00O00O0O0 =OOO0O0O0O00OO0O00 .GetSize ()#line:183
        if ReadPrefValue (ID_PREF_THUMB_MARKER_LAYER_COLOR )and O00O0OO0OO0O00000 is not None :#line:185
            OO0O00O0O00OOO000 =O00O0OO0OO0O00000 ['color']#line:186
        else :#line:188
            OO0O00O0O00OOO000 =ReadPrefValue (ID_PREF_THUMB_MARKER_COLOR )#line:189
        O0000OO0O0OO0O000 =int (OO0O00O0O00OOO000 .x *255.0 )#line:191
        OOO000O0000O0OOOO =int (OO0O00O0O00OOO000 .y *255.0 )#line:192
        OO0O0OO0O0O000O0O =int (OO0O00O0O00OOO000 .z *255.0 )#line:193
        for O0O0O000OOO00OO0O in range (OOO00O0O00O00O0O0 ):#line:195
            for OOOO00O00O00OOOO0 in range (OOOOOO0OOOOO00OO0 ):#line:196
                O0O000OOOOO0O0000 =float (OOO0O0O0O00OO0O00 .GetAlphaPixel (OO0OO0OO00O00000O ,OOOO00O00O00OOOO0 ,O0O0O000OOO00OO0O ))/255.0 #line:197
                OOOOOOOOOO0OO00OO =OOOO00O00O00OOOO0 #line:199
                OOO00O0OOO00OO00O =O0OOOO000OOO0O0OO -OOOO00O00O00OOOO0 #line:200
                OO00OOO00OOOO0O00 =O0O0O000OOO00OO0O #line:201
                OO000OOOO000000OO =OOO0OOOO0OOO0O000 -O0O0O000OOO00OO0O #line:202
                if OOO0O00OO0O0OO000 &0x01 :#line:204
                    BlendPixel (O0O0000OO000OO00O ,O0OOOOOOO0OOO0OO0 ,O0000OO0O0OO0O000 ,OOO000O0000O0OOOO ,OO0O0OO0O0O000O0O ,O0O000OOOOO0O0000 ,OOOOOOOOOO0OO00OO ,OO00OOO00OOOO0O00 )#line:205
                if OOO0O00OO0O0OO000 &0x02 :#line:207
                    BlendPixel (O0O0000OO000OO00O ,O0OOOOOOO0OOO0OO0 ,O0000OO0O0OO0O000 ,OOO000O0000O0OOOO ,OO0O0OO0O0O000O0O ,O0O000OOOOO0O0000 ,OOO00O0OOO00OO00O ,OO00OOO00OOOO0O00 )#line:208
                if OOO0O00OO0O0OO000 &0x04 :#line:210
                    BlendPixel (O0O0000OO000OO00O ,O0OOOOOOO0OOO0OO0 ,O0000OO0O0OO0O000 ,OOO000O0000O0OOOO ,OO0O0OO0O0O000O0O ,O0O000OOOOO0O0000 ,OOOOOOOOOO0OO00OO ,OO000OOOO000000OO )#line:211
                if OOO0O00OO0O0OO000 &0x08 :#line:213
                    BlendPixel (O0O0000OO000OO00O ,O0OOOOOOO0OOO0OO0 ,O0000OO0O0OO0O000 ,OOO000O0000O0OOOO ,OO0O0OO0O0O000O0O ,O0O000OOOOO0O0000 ,OOO00O0OOO00OO00O ,OO000OOOO000000OO )#line:214
    def DrawActiveLabel (O0O00O000OO0O0O0O ,OOO0O00OOO00OOO0O ,OO0OO0O0OO000O0O0 ,OOO00O0OOO00O000O ,O0OO0O0O0O00OOO00 ,OO0000OOOO000OOO0 ,OOOO00O0OO00OO0OO ):#line:217
        if (OOO00O0OOO00O000O &0x10 )==0 :#line:218
            return #line:219
        if ReadPrefValue (ID_PREF_THUMB_SIZE )==0 :#line:221
            if OOOO00O0OO00OO0OO is None :#line:222
                O000OOO0000O0OOOO =O0O00O000OO0O0O0O ._bmpEditorCameraSmall #line:223
            else :#line:225
                O000OOO0000O0OOOO =O0O00O000OO0O0O0O ._bmpActiveCameraSmall #line:226
        else :#line:228
            if OOOO00O0OO00OO0OO is None :#line:229
                O000OOO0000O0OOOO =O0O00O000OO0O0O0O ._bmpEditorCamera #line:230
            else :#line:232
                O000OOO0000O0OOOO =O0O00O000OO0O0O0O ._bmpActiveCamera #line:233
        if O000OOO0000O0OOOO is None :#line:235
            print ('{0} ERROR: No active project image!'.format (PLUGIN_NAME ))#line:236
            return #line:237
        O00O00O0O0OOO00O0 ,OOOO0000O0000OOOO =O000OOO0000O0OOOO .GetSize ()#line:239
        OOO0000O0000O00O0 =(O0OO0O0O0O00OOO00 -O00O00O0O0OOO00O0 )//2 #line:241
        O0OO0OOO0OOOO00OO =(OO0000OOOO000OOO0 -OOOO0000O0000OOOO )//2 #line:242
        O0O0OO0O00OOOOO0O =O000OOO0000O0OOOO .GetInternalChannel ()#line:244
        if ReadPrefValue (ID_PREF_THUMB_LABEL_LAYER_COLOR )and OO0OO0O0OO000O0O0 is not None :#line:246
            O0O0O000O0O0O0OO0 =OO0OO0O0OO000O0O0 ['color']#line:247
        else :#line:249
            O0O0O000O0O0O0OO0 =ReadPrefValue (ID_PREF_THUMB_LABEL_COLOR )#line:250
        OO000OOO0O0OOO0O0 =int (O0O0O000O0O0O0OO0 .x *255.0 )#line:252
        OO00OO0O00O0O00O0 =int (O0O0O000O0O0O0OO0 .y *255.0 )#line:253
        O0000OOOO0O0O0OO0 =int (O0O0O000O0O0O0OO0 .z *255.0 )#line:254
        DrawOverlay (OOO0O00OOO00OOO0O ,O000OOO0000O0OOOO ,pos =-1 ,x =OOO0000O0000O00O0 ,y =O0OO0OOO0OOOO00OO ,xOffs =0 ,yOffs =0 ,customColor =True ,rCustom =OO000OOO0O0OOO0O0 ,gCustom =OO00OO0O00O0O00O0 ,bCustom =O0000OOOO0O0O0OO0 )#line:257
    def DrawActiveOverlay (O0OOOO0000OOO00OO ,OOOOOO0OOO0O00OO0 ,O00O0O0000O0O0O0O ,O0OOOO0O0OO00O0OO ):#line:260
        if O0OOOO0O0OO00O0OO ==0 :#line:261
            return #line:262
        O00O0OOOOO00O0000 ,O00OO000OOO000O0O =O00O0O0000O0O0O0O .GetSize ()#line:264
        OO0O000O0000OOOOO =None #line:266
        if OOOOOO0OOO0O00OO0 is not None :#line:267
            OO0O000O0000OOOOO =OOOOOO0OOO0O00OO0 .GetLayerData (OOOOOO0OOO0O00OO0 .GetDocument ())#line:268
        O0OOOO0000OOO00OO .DrawActiveMarker (O00O0O0000O0O0O0O ,OO0O000O0000OOOOO ,O0OOOO0O0OO00O0OO ,O00O0OOOOO00O0000 ,O00OO000OOO000O0O )#line:270
        O0OOOO0000OOO00OO .DrawActiveLabel (O00O0O0000O0O0O0O ,OO0O000O0000OOOOO ,O0OOOO0O0OO00O0OO ,O00O0OOOOO00O0000 ,O00OO000OOO000O0O ,OOOOOO0OOO0O00OO0 )#line:272
    def DrawIconOverlay (OO000OOO00OO0O0O0 ,O0OOOO0OOOO0O00O0 ,OOOOOO0O0OO0O0OO0 ,O0OO0OO0O0O00OOOO ):#line:275
        if not ReadPrefValue (ID_PREF_THUMB_OVERLAY_ICON ):#line:276
            return #line:277
        OO0OO0000O00O0000 =ScaleImage (GetCameraIcon (O0OOOO0OOOO0O00O0 ),w =O0OO0OO0O0O00OOOO ,h =O0OO0OO0O0O00OOOO )#line:279
        DrawOverlay (OOOOOO0O0OO0O0OO0 ,OO0OO0000O00O0000 ,pos =0 )#line:281
    def DrawAnimOverlay (OO00OO0O0OO0O0OO0 ,O0OOOOOO0000000O0 ,OO000OOO0OO0O0000 ,OOOO0OO0O0OO0OOO0 ,OOO00O00O0OO00OO0 ,O0O00OOOO000O00O0 ,O0OO0OO000000O0OO ):#line:284
        if not ReadPrefValue (ID_PREF_THUMB_OVERLAY_ANIM ):#line:285
            return #line:286
        OOO0000OO00OO0OOO =GetCameraTag (O0OOOOOO0000000O0 )#line:288
        if not IsAnimated (O0OOOOOO0000000O0 )and not IsAnimated (OOO0000OO00OO0OOO ):#line:290
            return #line:291
        OOO0OOO0000OO0OOO =ScaleImage (GetIconImage (ID_ICON_CAM_ANIMATED ),w =OOOO0OO0O0OO0OOO0 ,h =OOOO0OO0O0OO0OOO0 )#line:293
        DrawOverlay (OO000OOO0OO0O0000 ,OOO0OOO0000OO0OOO ,pos =1 ,customColor =True ,rCustom =OOO00O00O0OO00OO0 ,gCustom =O0O00OOOO000O00O0 ,bCustom =O0OO0OO000000O0OO )#line:295
    def DrawThumbDecorationsActive (OOOOO000OOO0000O0 ,OO0OO0000O00O00O0 ,O00OOOOOO000O00O0 ,OO00O0000OOO00O00 ,OO0OOO0O0000OOOOO ,O00O0000O0000O000 ):#line:298
        FadeImageToBackground (OO0OO0000O00O00O0 ,O00O0000O0000O000 )#line:299
        if OO0OOO0O0000OOOOO :#line:301
            if OO00O0000OOO00O00 :#line:302
                OOOOO000OOO0000O0 .DrawActiveOverlay (None ,OO0OO0000O00O00O0 ,OO0OOO0O0000OOOOO )#line:303
            else :#line:305
                OOOOO000OOO0000O0 .DrawActiveOverlay (O00OOOOOO000O00O0 ,OO0OO0000O00O00O0 ,OO0OOO0O0000OOOOO )#line:306
    def DrawThumbDecorations (O00O0O0000O0OO00O ,O000OO0OOO0OOOO00 ,OOO00O000O00OOOO0 ,O00O0O00OO00O0O00 ):#line:309
        O00OO0OO0O0O0O000 =ReadPrefValue (ID_PREF_THUMB_LABEL_COLOR )#line:310
        O0OOOO0O0O00OO0OO =int (O00OO0OO0O0O0O000 .x *255.0 )#line:312
        OO0O0O0O0OOO00OOO =int (O00OO0OO0O0O0O000 .y *255.0 )#line:313
        OOO00OO0O0O0O00OO =int (O00OO0OO0O0O0O000 .z *255.0 )#line:314
        if O00O0O00OO00O0O00 :#line:316
            if O000OO0OOO0OOOO00 .GetSize ()[0 ]>THUMB_RESOLUTIONS [0 ][0 ]:#line:317
                O00000000000O00O0 =2.0 #line:318
                O0O0O00OO00000OO0 =True #line:319
            else :#line:321
                O00000000000O00O0 =1.25 #line:322
                O0O0O00OO00000OO0 =False #line:323
            O000OO0OOO0OOOO00 =DrawTextOverlay (O000OO0OOO0OOOO00 ,'E',O00000000000O00O0 ,O0O0O00OO00000OO0 ,italic =False ,r =O0OOOO0O0O00OO0OO ,g =OO0O0O0O0OOO00OOO ,b =OOO00OO0O0O0O00OO ,x =0 ,y =-4 )#line:325
        else :#line:327
            if O000OO0OOO0OOOO00 .GetSize ()[0 ]>THUMB_RESOLUTIONS [0 ][0 ]:#line:328
                O000O0O000OO0000O =19 #line:329
            else :#line:331
                O000O0O000OO0000O =16 #line:332
            O00O0O0000O0OO00O .DrawIconOverlay (OOO00O000O00OOOO0 ,O000OO0OOO0OOOO00 ,O000O0O000OO0000O )#line:334
            O00O0O0000O0OO00O .DrawAnimOverlay (OOO00O000O00OOOO0 ,O000OO0OOO0OOOO00 ,O000O0O000OO0000O ,O0OOOO0O0O00OO0OO ,OO0O0O0O0OOO00OOO ,OOO00OO0O0O0O00OO )#line:336
        return O000OO0OOO0OOOO00 #line:338
    def QueueRenderJobThumb (O0O00O00OOOO0O0O0 ,O000OO0OOOO0OO000 ,OOOOO0O00O0OOO00O ,O00O000O00O00O000 ,O00O0OO0O000OOO0O ,O00O00O0OOOOO00O0 ):#line:341
        O0O0O0O0O0OO0OO0O ,O00OOOOO0OOOOO0O0 =CloneDocumentFocussed (OOOOO0O00O0OOO00O ,O00O0OO0O000OOO0O ,cloneOnly =O00O00O0OOOOO00O0 )#line:342
        if O0O0O0O0O0OO0OO0O is None :#line:343
            PrintError ('Failed to clone document')#line:344
            return False #line:345
        OOO0O0OO0O00000OO =O0O0O0O0O0OO0OO0O .GetRenderBaseDraw ()#line:347
        OOO0O0OO0O00000OO .SetSceneCamera (O00OOOOO0OOOOO0O0 )#line:348
        OOOO0000000O0OO00 =GetThumbRenderData (O0O0O0O0O0OO0OO0O )#line:350
        if DetectProgressiveRender (O0O0O0O0O0OO0OO0O ):#line:352
            ShowProgressiveRenderError ()#line:353
            return False #line:354
        O0O000000000000OO =ReadPrefValue (ID_PREF_THUMB_ASPECT_RATIO )#line:356
        if O0O000000000000OO ==0 :#line:358
            O0OO00OOOO0OOO0O0 ={}#line:359
            O0OO00OOOO0OOO0O0 ['cl']=0 #line:360
            O0OO00OOOO0OOO0O0 ['cr']=THUMB_RENDER_RESOLUTION [0 ]#line:361
            O0OO00OOOO0OOO0O0 ['ct']=0 #line:362
            O0OO00OOOO0OOO0O0 ['cb']=THUMB_RENDER_RESOLUTION [1 ]#line:363
        elif O0O000000000000OO ==1 :#line:365
            O0OO00OOOO0OOO0O0 =c4d .documents .GetActiveDocument ().GetRenderBaseDraw ().GetFrame ()#line:366
        elif O0O000000000000OO ==2 :#line:368
            O0OO00OOOO0OOO0O0 =c4d .documents .GetActiveDocument ().GetRenderBaseDraw ().GetSafeFrame ()#line:369
        else :#line:371
            PrintError ('Unknown aspect ration id ({0})'.format (O0O000000000000OO ))#line:372
        if O0O000000000000OO ==1 or O0O000000000000OO ==2 :#line:374
            if O0O000000000000OO ==1 :#line:375
                O0OO00OOOO0OOO0O0 =c4d .documents .GetActiveDocument ().GetRenderBaseDraw ().GetFrame ()#line:376
            else :#line:378
                O0OO00OOOO0OOO0O0 =c4d .documents .GetActiveDocument ().GetRenderBaseDraw ().GetSafeFrame ()#line:379
            OOOOO0OO0OO000000 =O0OO00OOOO0OOO0O0 ['cr']-O0OO00OOOO0OOO0O0 ['cl']#line:381
            OO0OO000OO00O0O0O =O0OO00OOOO0OOO0O0 ['cb']-O0OO00OOOO0OOO0O0 ['ct']#line:382
            if OOOOO0OO0OO000000 >=OO0OO000OO00O0O0O :#line:384
                OOOO0000000O0OO00 [c4d .RDATA_XRES ]=THUMB_RENDER_RESOLUTION [0 ]#line:385
                OOOO0000000O0OO00 [c4d .RDATA_YRES ]=int (THUMB_RENDER_RESOLUTION [1 ]*(float (OO0OO000OO00O0O0O )/float (OOOOO0OO0OO000000 )))#line:386
            else :#line:388
                OOOO0000000O0OO00 [c4d .RDATA_XRES ]=int (THUMB_RENDER_RESOLUTION [0 ]*(float (OOOOO0OO0OO000000 )/float (OO0OO000OO00O0O0O )))#line:389
                OOOO0000000O0OO00 [c4d .RDATA_YRES ]=THUMB_RENDER_RESOLUTION [1 ]#line:390
        O000OO0OOOO0OO000 [O00O000O00O00O000 ]=None #line:392
        O0O00O00OOOO0O0O0 ._deferredRenderer .AddJob (OOOOO0O00O0OOO00O ,O00O000O00O00O000 ,O0O0O0O0O0OO0OO0O ,convertMultipassBitmap =True )#line:394
        return True #line:396
    def CreateLayoutAddMenu_File (OOO0O0O0O0OOOOOOO ):#line:399
        if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Menu'):#line:400
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Create Cam'):#line:401
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_STANDARD ,'Standard Camera')#line:402
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_TARGET ,'Target Camera')#line:403
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_MOTION ,'Motion Camera')#line:404
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_STEREO ,'Stereo Camera')#line:405
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_CRANE ,'Camera Crane')#line:406
                OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:407
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_PREVIEW ,'{0}'.format (PLUGIN_NAME_TAG_PREVIEW_CAMERA ))#line:408
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_PREVIEW_INSIDEOUT ,'{0} Look Around Camera'.format (PLUGIN_NAME ))#line:409
                if HaveRedshift ():#line:411
                    OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:412
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_RS_STANDARD ,'Redshift Standard Camera')#line:413
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_RS_FISHEYE ,'Redshift Fisheye Camera')#line:414
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_RS_SPHERICAL ,'Redshift Spherical Camera')#line:415
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_RS_CYLINDRICAL ,'Redshift Cylindrical Camera')#line:416
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_RS_STEREO_SPHERICAL ,'Redshift Stereo-Spherical Camera')#line:417
                if HaveCorona ():#line:419
                    OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:420
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_CO_STANDARD ,'Corona Camera')#line:421
                if HaveOctane ():#line:423
                    OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:424
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_OC_STANDARD ,'Octane Camera')#line:425
                if HaveVray ():#line:427
                    OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:428
                    OOO0O0O0O0OOOOOOO .MenuAddString (ID_CREATE_CAMERA_VR_PHYSICAL ,'Vray Physical Cameras')#line:429
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:431
            OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:433
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Render All Cams'):#line:435
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_ALL_TO_PV ,'... According to Preferences')#line:436
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_ALL_TO_PV_VP ,'... with Viewport look')#line:437
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_ALL_TO_PV_CURRENT_RD ,'... with Current Settings')#line:438
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:440
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Render Cam Proof Sheet'):#line:442
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_PROOF_SHEET ,'... According to Preferences')#line:443
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_PROOF_SHEET_VP ,'... with Viewport look')#line:444
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_PROOF_SHEET_CURRENT_RD ,'... with Current Settings')#line:445
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:447
            OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:449
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Editor Visibility For All Cams'):#line:451
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_EDITOR_VISIBILITY_ALL_DEFAULT ,'Default')#line:452
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_EDITOR_VISIBILITY_ALL_ON ,'On')#line:453
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_EDITOR_VISIBILITY_ALL_OFF ,'Off')#line:454
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:455
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Render Visibility For All Cams'):#line:457
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_VISIBILITY_ALL_DEFAULT ,'Default')#line:458
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_VISIBILITY_ALL_ON ,'On')#line:459
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_VISIBILITY_ALL_OFF ,'Off')#line:460
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:461
            OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:463
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Create Render Settings'):#line:465
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_ADD_THUMB_RENDER_SETTINGS ,'Thumbnails')#line:466
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_ADD_PROOF_SHEET_RENDER_SETTINGS ,'Proof Sheet')#line:467
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_ADD_RENDER_ALL_RENDER_SETTINGS ,'Render All Cams')#line:468
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:469
            OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:471
            OOO0O0O0O0OOOOOOO .MenuAddString (ID_RENDER_ALL_THUMBS ,'Update All Thumbnails')#line:473
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Thumbnail Size'):#line:475
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_MENU_THUMB_SIZE_SMALL ,'Small')#line:476
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_MENU_THUMB_SIZE_MEDIUM ,'Medium')#line:477
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_MENU_THUMB_SIZE_LARGE ,'Large')#line:478
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:480
            OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:482
            if OOO0O0O0O0OOOOOOO .MenuSubBegin ('Design'):#line:484
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_BITMAPBUTTON_ENABLE_COMBO ,'Show Dropdown')#line:485
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_BITMAPBUTTON_ENABLE_TABS ,'Show Tabs')#line:486
                OOO0O0O0O0OOOOOOO .MenuAddString (ID_BITMAPBUTTON_ENABLE_THUMBS ,'Show Thumbnails')#line:487
            OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:489
            OOO0O0O0O0OOOOOOO .MenuAddString (ID_CALL_PREFERENCES ,'Preferences...')#line:491
            OOO0O0O0O0OOOOOOO .MenuAddSeparator ()#line:495
            OOO0O0O0O0OOOOOOO .MenuAddString (ID_CALL_ABOUT ,'About...')#line:499
        OOO0O0O0O0OOOOOOO .MenuSubEnd ()#line:501
        OOO0O0O0O0OOOOOOO .MenuInitString (ID_BITMAPBUTTON_ENABLE_COMBO ,True ,ReadPrefValue (ID_PREF_COMBO_ENABLED ))#line:503
        OOO0O0O0O0OOOOOOO .MenuInitString (ID_BITMAPBUTTON_ENABLE_TABS ,True ,ReadPrefValue (ID_PREF_TABS_ENABLED ))#line:504
        OOO0O0O0O0OOOOOOO .MenuInitString (ID_BITMAPBUTTON_ENABLE_THUMBS ,True ,ReadPrefValue (ID_PREF_THUMB_ENABLED ))#line:505
        O0O000O00O0OO00O0 =ReadPrefValue (ID_PREF_THUMB_SIZE )#line:507
        OOO0O0O0O0OOOOOOO .MenuInitString (ID_MENU_THUMB_SIZE_SMALL ,True ,O0O000O00O0OO00O0 ==0 )#line:508
        OOO0O0O0O0OOOOOOO .MenuInitString (ID_MENU_THUMB_SIZE_MEDIUM ,True ,O0O000O00O0OO00O0 ==1 )#line:509
        OOO0O0O0O0OOOOOOO .MenuInitString (ID_MENU_THUMB_SIZE_LARGE ,True ,O0O000O00O0OO00O0 ==2 )#line:510
    def CreateLayoutAddMenu_Cameras (OO0O00OOO00OO0O00 ,O00O0O00O0O0OO0O0 ,OO0OOO0000O00O0OO ):#line:513
        if OO0O00OOO00OO0O00 .MenuSubBegin ('Cams'):#line:514
            for O0000OOOOO0OO000O ,(O00OO0O000000OOO0 ,_OOOOOO000OO0O00OO ,_OOOOOO000OO0O00OO ,_OOOOOO000OO0O00OO ,OO0OOOOOOO0O0OO0O )in enumerate (OO0OOO0000O00O0OO ):#line:515
                if OO0OOOOOOO0O0OO0O :#line:516
                    OO00OOOOOOO000OOO ='Editor Cam'#line:517
                    OO0O00OOO00OO0O00 .MenuAddSeparator ()#line:519
                else :#line:521
                    OO00OOOOOOO000OOO =O00OO0O000000OOO0 .GetName ()#line:522
                OOO00OO0OOOO00OO0 =O00O0O00O0O0OO0O0 ==O00OO0O000000OOO0 #line:524
                OO0O00OOO00OO0O00 .MenuAddString (ID_BASE_MENU_CAMERAS +O0000OOOOO0OO000O ,OO00OOOOOOO000OOO )#line:526
                OO0O00OOO00OO0O00 .MenuInitString (ID_BASE_MENU_CAMERAS +O0000OOOOO0OO000O ,True ,OOO00OO0OOOO00OO0 )#line:527
        OO0O00OOO00OO0O00 .MenuSubEnd ()#line:529
    def CreateLayoutAddMenu (OO0OOO0O0O0OO0OOO ,objCamActive =None ,cameras =[]):#line:532
        OO0OOO0O0O0OO0OOO .MenuFlushAll ()#line:533
        if ReadPrefValue (ID_PREF_MENU_FILES_ENABLED ):#line:535
            OO0OOO0O0O0OO0OOO .CreateLayoutAddMenu_File ()#line:536
        if ReadPrefValue (ID_PREF_MENU_CAMERAS_ENABLED ):#line:538
            OO0OOO0O0O0OO0OOO .CreateLayoutAddMenu_Cameras (objCamActive ,cameras )#line:539
        OO0OOO0O0O0OO0OOO .MenuFinished ()#line:541
    def CreateLayoutAddMenuCommandBar (O0OO0OO000O0O00OO ):#line:544
        O0OO0OO000O0O00OO .GroupBeginInMenuLine ()#line:545
        if ReadPrefValue (ID_PREF_PREV_NEXT_BUTTONS_ENABLED ):#line:547
            CreateLayoutAddBitmapButton (O0OO0OO000O0O00OO ,ID_BUTTON_PREV_CAM ,ID_ICON_PREV_CAMERA ,tooltip ='Previous Cam',button =True ,toggle =False ,flags =c4d .BFH_RIGHT ,inMenu =True )#line:549
            CreateLayoutAddBitmapButton (O0OO0OO000O0O00OO ,ID_BUTTON_NEXT_CAM ,ID_ICON_NEXT_CAMERA ,tooltip ='Next Cam',button =True ,toggle =False ,flags =c4d .BFH_RIGHT ,inMenu =True )#line:551
        if ReadPrefValue (ID_PREF_ALL_CAMS_BUTTON_ENABLED ):#line:553
            O0OO0OO000O0O00OO ._bitmapButtonCommandPanel =CreateLayoutAddBitmapButton (O0OO0OO000O0O00OO ,ID_BUTTON_ALL_CAMS_POPUP ,bmp1 =O0OO0OO000O0O00OO ._bmpCommandPanel ,tooltip ='{0} Command Panel'.format (PLUGIN_NAME ),button =True ,toggle =False ,flags =c4d .BFH_RIGHT ,inMenu =True )#line:555
        if ReadPrefValue (ID_PREF_DESIGN_BUTTONS_ENABLED ):#line:558
            O0OO0OO000O0O00OO ._bitmapButtonDesignPopup =CreateLayoutAddBitmapButton (O0OO0OO000O0O00OO ,ID_BITMAPBUTTON_POPUP_DESIGN ,c4d .RESOURCEIMAGE_LAYERMANAGER_STATE1 ,tooltip ='Designs',button =True ,toggle =False ,flags =c4d .BFH_RIGHT |c4d .BFV_CENTER ,inMenu =True )#line:560
        if ReadPrefValue (ID_PREF_UPDATE_THUMBS_BUTTON_ENABLED ):#line:562
            CreateLayoutAddBitmapButton (O0OO0OO000O0O00OO ,ID_BUTTON_UPDATE_ALL_THUMBS ,ID_ICON_UPDATE_ALL_THUMBS ,tooltip ='Update All Thumbnails',button =True ,toggle =False ,flags =c4d .BFH_RIGHT ,inMenu =True )#line:564
        if ReadPrefValue (ID_PREF_SETTINGS_BUTTON_ENABLED ):#line:566
            CreateLayoutAddBitmapButton (O0OO0OO000O0O00OO ,ID_CALL_PREFERENCES ,ID_ICON_PREFS ,tooltip ='Preferences',button =True ,toggle =False ,flags =c4d .BFH_RIGHT |c4d .BFV_CENTER ,inMenu =True )#line:567
        O0OO0OO000O0O00OO .GroupEnd ()#line:569
    def CreateLayoutGroupDesignCombo (O000000000OOO00OO ):#line:572
        if ReadPrefValue (ID_PREF_LARGE_COMBO ):#line:573
            O0O0O000OOOOO0O00 =30 #line:574
            O0O00OO0O0OO00O0O =1.0 #line:575
        else :#line:577
            O0O0O000OOOOO0O00 =0 #line:578
            O0O00OO0O0OO00O0O =0.5 #line:579
        if O000000000OOO00OO .GroupBegin (ID_GROUP_DESIGN_COMBO ,c4d .BFH_SCALEFIT |c4d .BFV_TOP ,rows =1 ):#line:581
            O000000000OOO00OO .AddComboBox (ID_COMBO_CAMERAS ,c4d .BFH_SCALEFIT |c4d .BFV_CENTER ,inith =O0O0O000OOOOO0O00 )#line:582
            CreateLayoutAddBitmapButton (O000000000OOO00OO ,ID_BUTTON_CURRENT_CAM ,bmp1 =GetIconImage (ID_ICON_CURRENT_CAM ,factor =O0O00OO0O0OO00O0O ),tooltip ='Current Cam Options',button =True ,toggle =False ,flags =c4d .BFH_LEFT ,inMenu =False )#line:585
        O000000000OOO00OO .GroupEnd ()#line:587
    def CreateLayoutGroupDesignTabs (OO0OO0O0OOO00O00O ):#line:590
        if OO0OO0O0OOO00O00O .GroupBegin (ID_GROUP_DESIGN_TABS ,c4d .BFH_SCALEFIT |c4d .BFV_TOP ):#line:591
            OO0OO0O0OOO00O00O ._quickTabCameras =CreateLayoutAddQuickTab (OO0OO0O0OOO00O00O ,ID_QUICKTAB_CAMERAS )#line:592
        OO0OO0O0OOO00O00O .GroupEnd ()#line:594
    def CreateLayoutGroupDesignThumbs (OO00O00O00O0OO00O ):#line:597
        if OO00O00O00O0OO00O .GroupBegin (ID_GROUP_DESIGN_THUMBS ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ):#line:598
            if OO00O00O00O0OO00O .ScrollGroupBegin (ID_SCROLLGROUP_CAMERAS ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,c4d .SCROLLGROUP_HORIZ |c4d .SCROLLGROUP_AUTOHORIZ |c4d .SCROLLGROUP_VERT |c4d .SCROLLGROUP_AUTOVERT ,initw =0 ,inith =37 ):#line:599
                if OO00O00O00O0OO00O .GroupBegin (ID_GROUP_CONTENT_SCROLLGROUP_CAMERAS ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,cols =1 ):#line:600
                    OO00O00O00O0OO00O .GroupBorderSpace (0 ,0 ,0 ,0 )#line:601
                    if OO00O00O00O0OO00O .GroupBegin (ID_GROUP_CAMERAS_THUMBNAIL_COLUMNS ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,cols =1 ):#line:603
                        pass #line:604
                    OO00O00O00O0OO00O .GroupEnd ()#line:606
                OO00O00O00O0OO00O .GroupEnd ()#line:608
            OO00O00O00O0OO00O .GroupEnd ()#line:610
        OO00O00O00O0OO00O .GroupEnd ()#line:612
    def CreateLayoutGroupCameraAttributes (O000O0O00O0OOOO0O ):#line:615
        OOOO000O0O0O0OO0O =ReadPrefValue (ID_PREF_SHOW_ATTRIBUTES )#line:616
        if OOOO000O0O0O0OO0O ==0 :#line:618
            O000O0O00O0OOOO0O ._cameraAttributes =None #line:619
            return #line:620
        O00OO0OO00O000000 =c4d .BaseContainer ()#line:622
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_ALLOWFOLDING ,True )#line:623
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_SHOWTITLE ,True )#line:624
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_NOUNDO ,False )#line:625
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_OBJECTSNOTINDOC ,False )#line:626
        O00OO0OO00O000000 .SetInt32 (c4d .DESCRIPTION_MODALMODE ,1 )#line:628
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_LEFTMATEDITREGION ,False )#line:629
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_SCALE_ALL_ELEMENTS ,False )#line:632
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_NO_SHOW_SUBCHANNELS ,False )#line:633
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_OPEN_ALL_GROUPS ,False )#line:634
        O00OO0OO00O000000 .SetBool (c4d .DESCRIPTION_NO_TAKE_OVERRIDES ,False )#line:635
        if O000O0O00O0OOOO0O .GroupBegin (0 ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ):#line:640
            O000O0O00O0OOOO0O ._cameraAttributes =O000O0O00O0OOOO0O .AddCustomGui (ID_CAMERA_ATTRIBUTES ,c4d .CUSTOMGUI_DESCRIPTION ,'',c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,0 ,0 ,O00OO0OO00O000000 )#line:641
        O000O0O00O0OOOO0O .GroupEnd ()#line:643
        OOOOO0O0O00OO0O00 ,O00000OO0OO0O0000 =GetActiveCamera ()#line:645
        O000O0O00O0OOOO0O ._cameraAttributes .SetObject (OOOOO0O0O00OO0O00 )#line:647
    def CreateLayoutGroupMain (O0OO00O000OO0000O ):#line:650
        OOOO0O0000O00O0OO =ReadPrefValue (ID_PREF_SHOW_ATTRIBUTES )#line:651
        OOOOOOOOO00O0OOO0 =1 #line:652
        OO000O0O00000O00O =0 #line:653
        O000OO00O000OO0OO =0 #line:654
        if OOOO0O0000O00O0OO ==1 :#line:656
            OOOOOOOOO00O0OOO0 =0 #line:657
            OO000O0O00000O00O =2 #line:658
            O000OO00O000OO0OO |=c4d .BFV_GRIDGROUP_ALLOW_WEIGHTS #line:659
        elif OOOO0O0000O00O0OO ==2 :#line:661
            OOOOOOOOO00O0OOO0 =2 #line:662
            OO000O0O00000O00O =0 #line:663
            O000OO00O000OO0OO |=c4d .BFV_GRIDGROUP_ALLOW_WEIGHTS #line:664
        O0OO00O000OO0000O ._bcWeights =ReadPrefValue (ID_PREF_WEIGHTS )#line:666
        if len (O0OO00O000OO0000O ._bcWeights )==0 :#line:668
            O0OO00O000OO0000O ._bcWeights =GetDefaultWeightBC (OOOO0O0000O00O0OO )#line:669
        if O0OO00O000OO0000O .GroupBegin (ID_GROUP_CONTENT ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,cols =OOOOOOOOO00O0OOO0 ,rows =OO000O0O00000O00O ,groupflags =O000OO00O000OO0OO ):#line:671
            if O0OO00O000OO0000O .GroupBegin (0 ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,cols =1 ):#line:672
                O0OO00O000OO0000O .CreateLayoutGroupDesignCombo ()#line:673
                O0OO00O000OO0000O .CreateLayoutGroupDesignTabs ()#line:674
                O0OO00O000OO0000O .CreateLayoutGroupDesignThumbs ()#line:675
            O0OO00O000OO0000O .GroupEnd ()#line:677
            O0OO00O000OO0000O .CreateLayoutGroupCameraAttributes ()#line:679
            O0OO00O000OO0000O .GroupWeightsLoad (ID_GROUP_CONTENT ,O0OO00O000OO0000O ._bcWeights )#line:681
        O0OO00O000OO0000O .GroupEnd ()#line:683
    def CreateCameraThumbnail (OOOOO00O00OOOOOO0 ,OOO00OO0OO0OOOO00 ,OOOO000O00O0O000O ,O00O00O0O0O00OOOO ,O00OO00O00O00O00O ,OOOOO0O00OOOO0O0O ,O0O0OO0O0O0O000O0 ,O000O0O00O0000OO0 ,O0OO00O00O0O0OOO0 ,O0000O0000O0000O0 ,O000OOO000O000O00 ,OOOOO0OO0O0O0OO0O ):#line:686
        OO0O00OO00O00O000 =c4d .BaseContainer ()#line:687
        O00O0OOOO00O0O00O ='<b>{0}</b>\n'.format (O00O00O0O0O00OOOO )#line:689
        O00O0OOOO00O0O00O +='[Shift+Click] More Options...\n'#line:690
        if not O0O0OO0O0O0O000O0 :#line:691
            O00O0OOOO00O0O00O +='[Double Click] Activate and Select\n'#line:692
            O00O0OOOO00O0O00O +='[Ctrl+Click] Select\n'#line:693
            O00O0OOOO00O0O00O +='[Shift+Ctrl+Click] Delete\n'#line:694
        OO0O00OO00O00O000 .SetString (c4d .BITMAPBUTTON_TOOLTIP ,O00O0OOOO00O0O00O )#line:696
        OO0O00OO00O00O000 .SetInt32 (c4d .BITMAPBUTTON_IGNORE_BITMAP_WIDTH ,False )#line:697
        OO0O00OO00O00O000 .SetInt32 (c4d .BITMAPBUTTON_IGNORE_BITMAP_HEIGHT ,False )#line:698
        OO0O00OO00O00O000 .SetBool (c4d .BITMAPBUTTON_BUTTON ,True )#line:699
        OO0O00OO00O00O000 .SetBool (c4d .BITMAPBUTTON_DRAWPOPUPBUTTON ,False )#line:700
        if ReadPrefValue (ID_PREF_THUMB_TITLE ):#line:702
            OOOOO00O00OOOOOO0 .GroupBegin (0 ,c4d .BFH_CENTER |c4d .BFV_TOP ,title =O00O00O0O0O00OOOO )#line:703
            if OOOOO0O00OOOO0O0O :#line:705
                OOOOO00O00OOOOOO0 .GroupBorder (c4d .BORDER_GROUP_TOP |c4d .BORDER_WITH_TITLE_BOLD )#line:706
            else :#line:708
                OOOOO00O00OOOOOO0 .GroupBorder (c4d .BORDER_NONE )#line:709
        else :#line:710
            OOOOO00O00OOOOOO0 .GroupBegin (0 ,c4d .BFH_CENTER |c4d .BFV_TOP ,title ='')#line:711
            OOOOO00O00OOOOOO0 .GroupBorderNoTitle (c4d .BORDER_NONE )#line:713
        OOOOO00O00OOOOOO0 .GroupBorderSpace (0 ,0 ,0 ,0 )#line:715
        OOOOO00O00OOOOOO0 .GroupSpace (0 ,0 )#line:716
        O0OO0OO0O00OOO0OO =OOOOO00O00OOOOOO0 .AddCustomGui (ID_BASE_THUMBS +OOO00OO0OO0OOOO00 ,c4d .CUSTOMGUI_BITMAPBUTTON ,'',c4d .BFH_CENTER |c4d .BFV_TOP ,O000OOO000O000O00 ,OOOOO0OO0O0O0OO0O ,OO0O00OO00O00O000 )#line:718
        if O00OO00O00O00O00O in O000O0O00O0000OO0 and O000O0O00O0000OO0 [O00OO00O00O00O00O ]is not None :#line:719
            O0OOOOOOOO0OO0O0O =O000O0O00O0000OO0 [O00OO00O00O00O00O ].GetClone ()#line:720
            if OOOOO0O00OOOO0O0O :#line:722
                OOOOO00O00OOOOOO0 .DrawThumbDecorationsActive (O0OOOOOOOO0OO0O0O ,OOOO000O00O0O000O ,O0O0OO0O0O0O000O0 ,O0000O0000O0000O0 ,O0OO00O00O0O0OOO0 )#line:723
            else :#line:725
                O0OOOOOOOO0OO0O0O =OOOOO00O00OOOOOO0 .DrawThumbDecorations (O0OOOOOOOO0OO0O0O ,OOOO000O00O0O000O ,O0O0OO0O0O0O000O0 )#line:726
            O0OO0OO0O00OOO0OO .SetImage (O0OOOOOOOO0OO0O0O ,True )#line:728
        else :#line:730
            O0OO0OO0O00OOO0OO .SetImage (OOOOO00O00OOOOOO0 ._bmpThumbRenderBusy ,False )#line:731
        OOOOO00O00OOOOOO0 .GroupEnd ()#line:733
    def CreateCamerasThumbnailGroup (O00O0OO0OO00O0OO0 ,noScroll =False ):#line:736
        if len (O00O0OO0OO00O0OO0 ._listDocs )<=0 :#line:737
            return False #line:738
        OO000OO0OOOO000OO =c4d .documents .GetActiveDocument ()#line:740
        O00O0O0O0OO00OO0O ,O00OOO0OOO000OOOO =GetActiveCamera (OO000OO0OOOO000OO )#line:742
        OO0OO0OO00O0OO0OO =GetDocBC (OO000OO0OOOO000OO )#line:744
        OOOOO0O00O0O000OO =CameraBCToList (OO0OO0OO00O0OO0OO )#line:746
        OOOO00OOOOO00O000 =GetDocThumbDict (O00O0OO0OO00O0OO0 ._listDocs ,OO000OO0OOOO000OO )#line:748
        O0OOOO0O000OOOO0O =O00O0OO0OO00O0OO0 .GetItemDim (ID_SCROLLGROUP_CAMERAS )#line:750
        OOOOO0000O0OOOOOO =O0OOOO0O000OOOO0O ['w']#line:752
        if OOOOO0000O0OOOOOO ==0 :#line:753
            OOOOO0000O0OOOOOO =300 #line:754
        O0O00O000O00000OO =ReadPrefValue (ID_PREF_THUMB_SIZE )#line:756
        OOOOO0OOO0OOO0000 =GetPrefThumbActiveOverlay ()#line:757
        O00OO0O00OOOOO00O =ReadPrefValue (ID_PREF_THUMB_HIDE_ACTIVE )#line:758
        OO00O0OO0O00O0000 =ReadPrefValue (ID_PREF_THUMB_FADE_ACTIVE )#line:759
        OOOO000OO00OO0OO0 ,O0OO0O0O0O0OOOO00 ,_O00000000O0O00O0O =THUMB_RESOLUTIONS [O0O00O000O00000OO ]#line:761
        OO00OO0OOO000O000 =(OOOOO0000O0OOOOOO +24 )//(OOOO000OO00OO0OO0 +8 +3 )#line:763
        OO00OO0OOO000O000 =max (1 ,OO00OO0OOO000O000 )#line:765
        OOOOO00000OOO0OOO =SHORTEN_NAMES_LENGTHS [O0O00O000O00000OO ]#line:767
        OO0O0OO0O0000000O =O00O0OO0OO00O0OO0 .ThumbHeightMax (OOOO00OOOOO00O000 ,O0OO0O0O0O0OOOO00 )#line:769
        OOO00OO00OO0OOOOO =c4d .gui .SizePix (OOOO000OO00OO0OO0 +4 )#line:773
        O0OO00O00O00OO000 =c4d .gui .SizePix (OO0O0OO0O0000000O +4 )#line:774
        O00O0OO0OO00O0OO0 .LayoutFlushGroup (ID_GROUP_CONTENT_SCROLLGROUP_CAMERAS )#line:775
        if O00O0OO0OO00O0OO0 .GroupBegin (0 ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,OO00OO0OOO000O000 ,groupflags =c4d .BFV_CMD_EQUALCOLUMNS ,title =''):#line:777
            OOO0O0OOOO0OO00O0 =None #line:779
            for O0O0O00O0O0000OOO ,(O00OOOO0O0OO00OOO ,_O00000000O0O00O0O ,_O00000000O0O00O0O ,O000000OO0OO0OOO0 ,O00OOO0OOO000OOOO )in enumerate (OOOOO0O00O0O000OO ):#line:780
                O00OOO0000O00OOOO =O00O0O0O0OO00OO0O ==O00OOOO0O0OO00OOO #line:781
                if O00OOO0000O00OOOO and O00OO0O00OOOOO00O :#line:783
                    continue #line:784
                if O00OOO0OOO000OOOO :#line:786
                    OOOOO0O000OO00OOO ='Editor Cam'#line:787
                else :#line:789
                    OOOOO0O000OO00OOO =O00OOOO0O0OO00OOO .GetName ()#line:790
                if len (OOOOO0O000OO00OOO )>OOOOO00000OOO0OOO :#line:792
                    OOOOO0O000OO00OOO =OOOOO0O000OO00OOO [:OOOOO00000OOO0OOO -2 ]+'...'#line:793
                O00O0OO0OO00O0OO0 .CreateCameraThumbnail (O0O0O00O0O0000OOO ,O00OOOO0O0OO00OOO ,OOOOO0O000OO00OOO ,O000000OO0OO0OOO0 ,O00OOO0000O00OOOO ,O00OOO0OOO000OOOO ,OOOO00OOOOO00O000 ,OO00O0OO0O00O0000 ,OOOOO0OOO0OOO0000 ,OOO00OO00OO0OOOOO ,O0OO00O00O00OO000 )#line:795
        O00O0OO0OO00O0OO0 .GroupEnd ()#line:797
        O00O0OO0OO00O0OO0 .LayoutChanged (ID_GROUP_CONTENT_SCROLLGROUP_CAMERAS )#line:799
        return True #line:801
    def InitThumbnails (OO0O0OO0O000O000O ,forceRender =False ):#line:805
        O000OOOOOO0OO0000 =c4d .documents .GetActiveDocument ()#line:806
        O0O00OOOO0O0OOO00 =GetDocBC (O000OOOOOO0OO0000 )#line:808
        O0OOOO00OOOOO0OO0 =CameraBCToList (O0O00OOOO0O0OOO00 )#line:810
        O00OOO000O00O0O0O =CameraBCToDict (O0O00OOOO0O0OOO00 )#line:811
        OO0O0OO0O000O000O ._listDocs =GetUpdatedDocList (listDocsOld =OO0O0OO0O000O000O ._listDocs )#line:813
        O0OO0OOOOO00OO00O =GetDocThumbDict (OO0O0OO0O000O000O ._listDocs ,O000OOOOOO0OO0000 )#line:815
        GarbageCollectDocThumbDict (O00OOO000O00O0O0O ,O0OO0OOOOO00OO00O )#line:817
        OO0O0OO0O000O000O ._deferredRenderer .Reset ()#line:819
        O0O0O00OO00OO0O0O =THUMB_RESOLUTIONS [ReadPrefValue (ID_PREF_THUMB_SIZE )][0 ]#line:821
        for OOO0O00OO0OOOO000 ,_OOOO0OO0OO0O00O0O ,_OOOO0OO0OO0O00O0O ,O0OO000OO0O000OOO ,O00OO0000OOOOOOO0 in O0OOOO00OOOOO0OO0 :#line:823
            if not forceRender and O0OO000OO0O000OOO in O0OO0OOOOO00OO00O and O0OO0OOOOO00OO00O [O0OO000OO0O000OOO ]is not None and O0OO0OOOOO00OO00O [O0OO000OO0O000OOO ].GetSize ()[0 ]==O0O0O00OO00OO0O0O :#line:824
                continue #line:825
            if not OO0O0OO0O000O000O .QueueRenderJobThumb (O0OO0OOOOO00OO00O ,O000OOOOOO0OO0000 ,O0OO000OO0O000OOO ,OOO0O00OO0OOOO000 ,O00OO0000OOOOOOO0 ):#line:827
                break #line:828
    def FillComboCameras (O00OO0O00O0OO0000 ,O0OO0O000O00OO00O ,cameras =[]):#line:831
        O00OO0O00O0OO0000 .FreeChildren (ID_COMBO_CAMERAS )#line:832
        O0O0O00000O0OO0O0 =None #line:834
        for O0OO00O00000000O0 ,(OOO0O00OOOOO00OOO ,_O0OO0O00OOO00O000 ,_O0OO0O00OOO00O000 ,_O0OO0O00OOO00O000 ,O0OOO0O000OO0OO00 )in enumerate (cameras ):#line:835
            if O0OOO0O000OO0OO00 :#line:836
                O0OOO00O0OOOOO000 ='Editor Cam'#line:837
                O00OO0O00O0OO0000 .AddChild (ID_COMBO_CAMERAS ,-1 ,'')#line:839
            else :#line:841
                O0OOO00O0OOOOO000 =OOO0O00OOOOO00OOO .GetName ()#line:842
            O00OO0O00O0OO0000 .AddChild (ID_COMBO_CAMERAS ,O0OO00O00000000O0 ,O0OOO00O0OOOOO000 )#line:844
            if OOO0O00OOOOO00OOO ==O0OO0O000O00OO00O :#line:846
                O0O0O00000O0OO0O0 =O0OO00O00000000O0 #line:847
        if O0O0O00000O0OO0O0 is not None :#line:849
            O00OO0O00O0OO0000 .SetInt32 (ID_COMBO_CAMERAS ,O0O0O00000O0OO0O0 )#line:850
        else :#line:852
            PrintError ('No active Cam???')#line:853
    def FillTabsCameras (OO0000OO0OO0OOO00 ,O0OO0O00O0OO0000O ,cameras =[]):#line:856
        OO0000OO0OO0OOO00 ._quickTabCameras .ClearStrings ()#line:857
        for OO0OO00OO0000O00O ,(OO0O0OOO00000O000 ,_O0000OOOO00OOOO00 ,_O0000OOOO00OOOO00 ,_O0000OOOO00OOOO00 ,O000OOO0OOOOOOO00 )in enumerate (cameras ):#line:859
            OOOOO0O0OOOOOO00O =OO0O0OOO00000O000 ==O0OO0O00O0OO0000O #line:860
            if O000OOO0OOOOOOO00 :#line:862
                O0O0OO00O00000OOO ='Editor Cam'#line:863
            else :#line:865
                O0O0OO00O00000OOO =OO0O0OOO00000O000 .GetName ()#line:866
            OO0000OO0OO0OOO00 ._quickTabCameras .AppendString (OO0OO00OO0000O00O ,O0O0OO00O00000OOO ,OOOOO0O0OOOOOO00O )#line:868
            O00O0O000OOO000OO =ReadPrefValue (ID_PREF_THUMB_LABEL_COLOR )#line:870
            OO0000OO0OO0OOO00 ._quickTabCameras .SetLayerColor (OO0OO00OO0000O00O ,O000OOO0OOOOOOO00 ,O00O0O000OOO000OO )#line:872
        OO0000OO0OO0OOO00 ._quickTabCameras .DoLayoutChange ()#line:874
    _lastDoc =None #line:877
    def UpdateCameraChanged (O0OOO000OOOO000OO ):#line:878
        O00O0O0O00OO000O0 =c4d .documents .GetActiveDocument ()#line:879
        OOOO000OOOOO0O0OO =GetDocBC (O00O0O0O00OO000O0 )#line:881
        O0OOO00OOO00OO000 =CameraBCToList (OOOO000OOOOO0O0OO )#line:883
        OO0O00OO00OOO0OO0 ,O00OOO0O00OO0O00O =GetActiveCamera (O00O0O0O00OO000O0 )#line:885
        O0OOO000OOOO000OO .CreateLayoutAddMenu (OO0O00OO00OOO0OO0 ,O0OOO00OOO00OO000 )#line:887
        O0OOO000OOOO000OO .FillComboCameras (OO0O00OO00OOO0OO0 ,O0OOO00OOO00OO000 )#line:889
        O0OOO000OOOO000OO .FillTabsCameras (OO0O00OO00OOO0OO0 ,O0OOO00OOO00OO000 )#line:890
        O0OOO000OOOO000OO .CreateCamerasThumbnailGroup ()#line:892
        if O0OOO000OOOO000OO ._cameraAttributes is not None :#line:894
            O0OOO000OOOO000OO ._cameraAttributes .SetObject (OO0O00OO00OOO0OO0 )#line:895
        O0OOO000OOOO000OO ._lastDoc =c4d .documents .GetActiveDocument ()#line:897
    def UpdateComboCameras (OO00O00O00O0O0OO0 ,O00OOOOOO0OO000O0 ,OOO0O0OOOOOOOOOOO ):#line:900
        OO0OO0OOOO000O00O =ReadPrefValue (ID_PREF_COMBO_ENABLED )#line:901
        OO00O00O00O0O0OO0 .LayoutFlushGroup (ID_GROUP_DESIGN_COMBO )#line:903
        if OO0OO0OOOO000O00O :#line:905
            if ReadPrefValue (ID_PREF_LARGE_COMBO ):#line:906
                O000OO00O0OOO0000 =30 #line:907
                OOOOOO0OOO000OOOO =1.0 #line:908
            else :#line:910
                O000OO00O0OOO0000 =0 #line:911
                OOOOOO0OOO000OOOO =0.5 #line:912
            OO00O00O00O0O0OO0 .AddComboBox (ID_COMBO_CAMERAS ,c4d .BFH_SCALEFIT |c4d .BFV_CENTER ,inith =O000OO00O0OOO0000 )#line:914
            CreateLayoutAddBitmapButton (OO00O00O00O0O0OO0 ,ID_BUTTON_CURRENT_CAM ,bmp1 =GetIconImage (ID_ICON_CURRENT_CAM ,factor =OOOOOO0OOO000OOOO ),tooltip ='Current Cam Options',button =True ,toggle =False ,flags =c4d .BFH_LEFT ,inMenu =False )#line:917
        OO00O00O00O0O0OO0 .LayoutChanged (ID_GROUP_MAIN_DIALOG )#line:919
        OO00O00O00O0O0OO0 .HideElement (ID_GROUP_DESIGN_COMBO ,not OO0OO0OOOO000O00O )#line:921
        OO00O00O00O0O0OO0 .FillComboCameras (O00OOOOOO0OO000O0 ,OOO0O0OOOOOOOOOOO )#line:923
    def UpdateDesign (OOO00OOO0OO0OOO0O ):#line:926
        OOOOOOOOO00O0O0O0 =c4d .documents .GetActiveDocument ()#line:927
        O0OO0O0O0OO0O0000 =GetDocBC (OOOOOOOOO00O0O0O0 )#line:929
        OOO0000OO000OOOOO =CameraBCToList (O0OO0O0O0OO0O0000 )#line:931
        OO0O0O0OO00O0OOOO ,O0O0O0O00O0OOO00O =GetActiveCamera (OOOOOOOOO00O0O0O0 )#line:933
        OOO00OOO0OO0OOO0O .CreateLayoutAddMenu (OO0O0O0OO00O0OOOO ,OOO0000OO000OOOOO )#line:935
        OOO00OOO0OO0OOO0O .UpdateComboCameras (OO0O0O0OO00O0OOOO ,OOO0000OO000OOOOO )#line:937
        OO000OO000OOO0O00 =ReadPrefValue (ID_PREF_COMBO_ENABLED )#line:939
        OO000OO00OOO0O0O0 =ReadPrefValue (ID_PREF_TABS_ENABLED )#line:940
        O0000OO0O00O0O000 =ReadPrefValue (ID_PREF_THUMB_ENABLED )#line:941
        OOO00OOO0OO0OOO0O .HideElement (ID_GROUP_DESIGN_TABS ,not OO000OO00OOO0O0O0 )#line:943
        OOO00OOO0OO0OOO0O .HideElement (ID_GROUP_DESIGN_THUMBS ,not O0000OO0O00O0O000 )#line:944
        if ReadPrefValue (ID_PREF_UPDATE_THUMBS_BUTTON_ENABLED ):#line:946
            OOO00OOO0OO0OOO0O .Enable (ID_BUTTON_UPDATE_ALL_THUMBS ,O0000OO0O00O0O000 )#line:947
        OOO00OOO0OO0OOO0O .MenuInitString (ID_RENDER_ALL_THUMBS ,O0000OO0O00O0O000 ,False )#line:949
        OOO00OOO0OO0OOO0O .MenuInitString (ID_BITMAPBUTTON_ENABLE_COMBO ,True ,OO000OO000OOO0O00 )#line:951
        OOO00OOO0OO0OOO0O .MenuInitString (ID_BITMAPBUTTON_ENABLE_TABS ,True ,OO000OO00OOO0O0O0 )#line:952
        OOO00OOO0OO0OOO0O .MenuInitString (ID_BITMAPBUTTON_ENABLE_THUMBS ,True ,O0000OO0O00O0O000 )#line:953
        O0O00O0O0O0OOO000 =ReadPrefValue (ID_PREF_THUMB_SIZE )#line:955
        OOO00OOO0OO0OOO0O .MenuInitString (ID_MENU_THUMB_SIZE_SMALL ,True ,O0O00O0O0O0OOO000 ==0 )#line:956
        OOO00OOO0OO0OOO0O .MenuInitString (ID_MENU_THUMB_SIZE_MEDIUM ,True ,O0O00O0O0O0OOO000 ==1 )#line:957
        OOO00OOO0OO0OOO0O .MenuInitString (ID_MENU_THUMB_SIZE_LARGE ,True ,O0O00O0O0O0OOO000 ==2 )#line:958
        OOO00OOO0OO0OOO0O .LayoutChanged (ID_GROUP_MAIN_DIALOG )#line:960
        if OO000OO00OOO0O0O0 :#line:962
            OOO00OOO0OO0OOO0O .FillTabsCameras (OO0O0O0OO00O0OOOO ,OOO0000OO000OOOOO )#line:963
        c4d .EventAdd ()#line:965
    def UpdateLastThumb (OO0OO000OO000O000 ,OO0OOO00O000O0OO0 ,OOOOO0O00O00O00OO ,O0OO0O0O0O0OOO0OO ):#line:969
        O0O0OOOOO0OO0000O =OOOOO0O00O00O00OO .GetInt32 (ID_CAM_IDX_UPDATE_THUMB_LAST )#line:970
        if O0O0OOOOO0OO0000O >=len (O0OO0O0O0O0OOO0OO ):#line:972
            return #line:973
        O00OO00O0O00OO0OO =O0OO0O0O0O0OOO0OO [O0O0OOOOO0OO0000O ][0 ]#line:975
        OOOOOO000O00OOOOO =O0OO0O0O0O0OOO0OO [O0O0OOOOO0OO0000O ][3 ]#line:976
        OO00OOO0000O00O00 =O0OO0O0O0O0OOO0OO [O0O0OOOOO0OO0000O ][4 ]#line:977
        OO00OO0000O000OOO =O0OO0O0O0O0OOO0OO [O0O0OOOOO0OO0000O ][1 ]#line:978
        OOOOOOO000OO000OO =O0OO0O0O0O0OOO0OO [O0O0OOOOO0OO0000O ][2 ]#line:979
        O00OOOO0OO0OO0O0O =O00OO00O0O00OO0OO .GetHDirty (HDIRTYFLAGS_OBJECT |HDIRTYFLAGS_OBJECT_MATRIX |HDIRTYFLAGS_TAG )#line:981
        if O00OOOO0OO0OO0O0O ==OO00OO0000O000OOO :#line:983
            return #line:984
        OOOOOOO000OO000OO .SetInt32 (ID_CAM_LAST_HDIRTY ,O00OOOO0OO0OO0O0O )#line:986
        OOOO0O0OO0OOO000O =GetDocThumbDict (OO0OO000OO000O000 ._listDocs ,OO0OOO00O000O0OO0 )#line:988
        OO0OO000OO000O000 .QueueRenderJobThumb (OOOO0O0OO0OOO000O ,OO0OOO00O000O0OO0 ,OOOOOO000O00OOOOO ,O00OO00O0O00OO0OO ,OO00OOO0000O00O00 )#line:990
    def UpdateThumbnails (OO0OOO000OOOOOOO0 ):#line:994
        if not ReadPrefValue (ID_PREF_THUMB_ENABLED ):#line:995
            return #line:996
        OO0OOO000OOOOOOO0 .InitThumbnails (forceRender =True )#line:998
        OO0OOO000OOOOOOO0 .CreateCamerasThumbnailGroup ()#line:1000
    def RedrawThumbnails (OOO00OO0OOO0OOOO0 ):#line:1004
        if not ReadPrefValue (ID_PREF_THUMB_ENABLED ):#line:1005
            return #line:1006
        OOO00OO0OOO0OOOO0 .InitThumbnails (forceRender =False )#line:1008
        OOO00OO0OOO0OOOO0 .CreateCamerasThumbnailGroup ()#line:1010
    def ReceiveRenderResultUpdateThumb (OO00O000O00OOOO00 ,O00O0O0O00O0OO000 ):#line:1013
        OO000OO000O000O0O =GetDocThumbDict (OO00O000O00OOOO00 ._listDocs ,O00O0O0O00O0OO000 ._docOrig )#line:1014
        if OO000OO000O000O0O is None :#line:1016
            return #line:1017
        OO000OO000O000O0O [O00O0O0O00O0OO000 ._idJob ]=OO00O000O00OOOO00 .ScaleThumb (O00O0O0O00O0OO000 ._bmpResult )#line:1019
    def CoreMessageReceiveRenderResult (OOOO0OOO0O0OO00O0 ):#line:1022
        OO00OO000OOOOO000 =OOOO0OOO0O0OO00O0 ._deferredRenderer .GetResult ()#line:1023
        O0000OOOOO0O000O0 =False #line:1025
        while OO00OO000OOOOO000 is not None :#line:1027
            if OO00OO000OOOOO000 .HasError ():#line:1028
                OO00OO000OOOOO000 .PrintError ()#line:1029
                OOOO0OOO0O0OO00O0 ._deferredRenderer .Reset ()#line:1031
                OO00OO000OOOOO000 =OOOO0OOO0O0OO00O0 ._deferredRenderer .GetResult ()#line:1033
                continue #line:1034
            if OO00OO000OOOOO000 ._flags &0xFFFF0000 ==0 :#line:1036
                OOOO0OOO0O0OO00O0 .ReceiveRenderResultUpdateThumb (OO00OO000OOOOO000 )#line:1037
                O0000OOOOO0O000O0 =True #line:1038
            elif OO00OO000OOOOO000 ._flags &0x80000000 ==0x80000000 :#line:1040
                PrintError ('Received image render result in DialogMain')#line:1041
            elif OO00OO000OOOOO000 ._flags &0x40000000 ==0x40000000 :#line:1043
                PrintError ('Received proof sheet render result in DialogMain')#line:1044
            OO00OO000OOOOO000 =OOOO0OOO0O0OO00O0 ._deferredRenderer .GetResult ()#line:1046
        if O0000OOOOO0O000O0 :#line:1048
            OOOO0OOO0O0OO00O0 .CreateCamerasThumbnailGroup ()#line:1049
    def CoreMessageCameraListChange (O0O000O0OOO0OO0OO ):#line:1052
        O0O000O0OOO0OO0OO .InitValues ()#line:1053
    def CoreMessageCameraActiveChange (OOO0O00OOOO0O000O ):#line:1056
        O000OOOOO0O0O00OO =c4d .documents .GetActiveDocument ()#line:1057
        O00O0O0O0OOOOO000 =GetDocBC (O000OOOOO0O0O00OO )#line:1059
        OOOOOOOO00OO0000O =CameraBCToList (O00O0O0O0OOOOO000 )#line:1061
        O00O00O0OOO00O000 ,OOOO0OO0OO0O000OO =GetActiveCamera (O000OOOOO0O0O00OO )#line:1063
        OOO0O00OOOO0O000O .CreateLayoutAddMenu (O00O00O0OOO00O000 ,OOOOOOOO00OO0000O )#line:1065
        OOO0O00OOOO0O000O .FillComboCameras (O00O00O0OOO00O000 ,OOOOOOOO00OO0000O )#line:1067
        OOO0O00OOOO0O000O .FillTabsCameras (O00O00O0OOO00O000 ,OOOOOOOO00OO0000O )#line:1068
        OOO0O00OOOO0O000O .RedrawThumbnails ()#line:1070
        if OOO0O00OOOO0O000O ._cameraAttributes is not None :#line:1072
            OOO0O00OOOO0O000O ._cameraAttributes .SetObject (O00O00O0OOO00O000 )#line:1073
        if ReadPrefValue (ID_PREF_THUMB_UPDATES )==1 :#line:1075
            OOO0O00OOOO0O000O .UpdateLastThumb (O000OOOOO0O0O00OO ,O00O0O0O0OOOOO000 ,OOOOOOOO00OO0000O )#line:1076
        O00O0O0O0OOOOO000 .RemoveData (ID_CAM_IDX_UPDATE_THUMB_LAST )#line:1078
    def CoreMessageChangeDesign (OOO0000O00OOO00O0 ):#line:1081
        OOO0000O00OOO00O0 .UpdateDesign ()#line:1082
        OOO0000O00OOO00O0 .UpdateThumbnails ()#line:1083
    def CoreMessageChangeMenuButtons (O0O00OOOO0O0OO0OO ):#line:1086
        if O0O00OOOO0O0OO0OO .IsOpen ():#line:1087
            O0O00OOOO0O0OO0OO .Close ()#line:1088
            O0O00OOOO0O0OO0OO .Open (c4d .DLG_TYPE_ASYNC ,PLUGIN_ID_CAMS ,xpos =-1 ,ypos =-1 ,defaultw =0 ,defaulth =0 )#line:1089
    def CoreMessageCloseDialog (OOO00OO0OO000000O ):#line:1092
        if OOO00OO0OO000000O .IsOpen ():#line:1093
            OOO00OO0OO000000O .Close ()#line:1094
    def CoreMessageThumbPopupCommand (O00OO00O00OO0OO00 ,OO00O0OO0O0O0OO00 ):#line:1097
        if O00OO00O00OO0OO00 ._dlgPopup is None :#line:1098
            return #line:1099
        O000000OOOOOO0000 ,O0OO0OOOOO0OOOO0O =DecodeCMPerCamSubId (OO00O0OO0O0O0OO00 )#line:1101
        OOO0000O0OOOO00O0 =c4d .documents .GetActiveDocument ()#line:1103
        O000OOO0OOOOOOOOO =GetDocBC (OOO0000O0OOOO00O0 )#line:1105
        O000O00OOO0000OOO =CameraBCToList (O000OOO0OOOOOOOOO )#line:1107
        if O0OO0OOOOO0OOOO0O >=len (O000O00OOO0000OOO ):#line:1109
            PrintError ('idxCam out of range')#line:1110
            return #line:1111
        OO0O0O00O0OOOOO0O =O000O00OOO0000OOO [O0OO0OOOOO0OOOO0O ][0 ]#line:1113
        OO0OOOO00O0O00OOO =O000O00OOO0000OOO [O0OO0OOOOO0OOOO0O ][4 ]#line:1114
        if O000000OOOOOO0000 ==ID_THUMB_MENU_UPDATE :#line:1116
            O00OO00O00OO0OO00 .CommandThumbUpdate (OOO0000O0OOOO00O0 ,O000O00OOO0000OOO ,O0OO0OOOOO0OOOO0O ,OO0O0O00O0OOOOO0O ,OO0OOOO00O0O00OOO )#line:1117
        if O00OO00O00OO0OO00 ._dlgPopup .IsOpen ():#line:1121
            PrintError ('Popup dialog still open?!?!?!')#line:1122
            O00OO00O00OO0OO00 ._dlgPopup .Close ()#line:1123
        O00OO00O00OO0OO00 ._dlgPopup =None #line:1125
    def CoreMessageCommandPanelPopupCommand (OO000O0OO0O0000O0 ):#line:1129
        if OO000O0OO0O0000O0 ._dlgPopupCommandPanel is None :#line:1130
            return #line:1131
        if OO000O0OO0O0000O0 ._dlgPopupCommandPanel .IsOpen ():#line:1133
            PrintError ('Popup dialog still open?!?!?!')#line:1134
            OO000O0OO0O0000O0 ._dlgPopupCommandPanel .Close ()#line:1135
        OO000O0OO0O0000O0 ._dlgPopupCommandPanel =None #line:1137
    def CoreMessageDesignPopupCommand (OO0O0OOO0O0O00000 ,keepOpen =False ):#line:1140
        if OO0O0OOO0O0O00000 ._dlgPopupDesign is None :#line:1141
            return #line:1142
        OO0O0O0OOOOOOO000 =OO0O0OOO0O0O00000 ._dlgPopupDesign .GetResult ()#line:1144
        if OO0O0O0OOOOOOO000 ==0 :#line:1146
            return #line:1147
        if OO0O0O0OOOOOOO000 ==ID_BITMAPBUTTON_ENABLE_THUMBS :#line:1149
            OO0O0OOO0O0O00000 .CommandEnableThumbs (changePrefs =False )#line:1150
        elif OO0O0O0OOOOOOO000 ==ID_BITMAPBUTTON_ENABLE_COMBO :#line:1152
            OO0O0OOO0O0O00000 .CommandEnableCombo (changePrefs =False )#line:1153
        elif OO0O0O0OOOOOOO000 ==ID_BITMAPBUTTON_ENABLE_TABS :#line:1155
            OO0O0OOO0O0O00000 .CommandEnableTabs (changePrefs =False )#line:1156
        elif OO0O0O0OOOOOOO000 ==ID_BITMAPBUTTON_THUMB_SIZE :#line:1158
            OO0O0OOO0O0O00000 .CommandThumbSize ()#line:1159
        elif OO0O0O0OOOOOOO000 ==ID_BITMAPBUTTON_TOGGLE_ATTRIBUTES :#line:1161
            OO0O0OOO0O0O00000 .CommandToggleLayoutAttributes (changePrefs =False )#line:1162
        if not keepOpen :#line:1164
            if OO0O0OOO0O0O00000 ._dlgPopupDesign .IsOpen ():#line:1165
                PrintWarn ('Popup dialog still open?!?!?!')#line:1166
                OO0O0OOO0O0O00000 ._dlgPopupDesign .Close ()#line:1167
            OO0O0OOO0O0O00000 ._dlgPopupDesign =None #line:1169
    def CommandThumbUpdate (OO0OOOOOOOOOO0000 ,O0OOOOO0O0O000OO0 ,O0O0OO0OO000O0OOO ,OO00OO0O0O0000O0O ,O0OOO0O0OOO0OOOOO ,O0O0OOOOO0O0O0000 ):#line:1173
        OO0OO0OOOOOOOO00O =O0O0OO0OO000O0OOO [OO00OO0O0O0000O0O ][3 ]#line:1174
        OO00OO00O0O0O00O0 =GetDocThumbDict (OO0OOOOOOOOOO0000 ._listDocs ,O0OOOOO0O0O000OO0 )#line:1176
        OO0OOOOOOOOOO0000 .QueueRenderJobThumb (OO00OO00O0O0O00O0 ,O0OOOOO0O0O000OO0 ,OO0OO0OOOOOOOO00O ,O0OOO0O0OOO0OOOOO ,O0O0OOOOO0O0O0000 )#line:1178
    def CommandThumbContextMenu (O00OOOO00OOOOO00O ,OOO00000O0OO000OO ):#line:1181
        O000OOO00O0O0O0OO =c4d .documents .GetActiveDocument ()#line:1182
        O000OO0OOO00OOOO0 =GetDocBC (O000OOO00O0O0O0OO )#line:1184
        OO00O0O0000O000OO =CameraBCToList (O000OO0OOO00OOOO0 )#line:1186
        OO0O0O0O0OO00O000 =GetDocThumbDict (O00OOOO00OOOOO00O ._listDocs ,O000OOO00O0O0O0OO )#line:1188
        OOO000OO0O00OO000 =OO00O0O0000O000OO [OOO00000O0OO000OO ][0 ]#line:1190
        OOOO0O0000O00OO00 =OO00O0O0000O000OO [OOO00000O0OO000OO ][4 ]#line:1191
        OO00000000O0OO0O0 =OO0O0O0O0OO00O000 [OO00O0O0000O000OO [OOO00000O0OO000OO ][3 ]]#line:1192
        O00OOOO00OOOOO00O .ShowPopupDialog (OOO00000O0OO000OO ,OOO000OO0O00OO000 ,OOOO0O0000O00OO00 ,OO00000000O0OO0O0 )#line:1194
        return #line:1196
    def CommandRenderAllCameras (O0000OO0OO0OO0OO0 ,O0OO0OO000OOO00O0 ):#line:1199
        ShowRenderInBackgroundInfo ()#line:1200
        if (O0000OO0OO0OO0OO0 ._flagsTimerReason &0x02 )==0x02 :#line:1202
            O00O0O0OO00OOO0O0 =ShowRenderInProgressQuestion ()#line:1203
            if O00O0O0OO00OOO0O0 ==1 :#line:1204
                c4d .SpecialEventAdd (PLUGIN_ID_CAMS_COREMESSAGE ,p1 =SUBID_COREMESSAGE_DEFERRED_RENDER_FLUSH_QUEUE )#line:1205
            elif O00O0O0OO00OOO0O0 ==2 :#line:1207
                return #line:1208
        c4d .SpecialEventAdd (PLUGIN_ID_CAMS_COREMESSAGE ,p1 =SUBID_COREMESSAGE_DLG_COMMAND_PANEL_BASE +O0OO0OO000OOO00O0 )#line:1210
    def CommandCommandPanelPopup (O0O00OO0O0O0O000O ,x =-1 ,y =-1 ):#line:1213
        if O0O00OO0O0O0O000O ._dlgPopupCommandPanel is not None :#line:1214
            O0O00OO0O0O0O000O ._dlgPopupCommandPanel .Close ()#line:1215
            O0O00OO0O0O0O000O ._dlgPopupCommandPanel =None #line:1216
        O0O00OO0O0O0O000O ._dlgPopupCommandPanel =DialogPopupCommandPanel (O0O00OO0O0O0O000O ._iconsPopupCommandPanel ,(O0O00OO0O0O0O000O ._flagsTimerReason &0x02 )==0x02 )#line:1218
        x ,y =AtMousePointer (O0O00OO0O0O0O000O ,x ,y )#line:1220
        O0O00OO0O0O0O000O ._dlgPopupCommandPanel .Open (dlgtype =c4d .DLG_TYPE_ASYNC_POPUPEDIT ,pluginid =0 ,xpos =x ,ypos =y ,defaultw =0 ,defaulth =0 ,subid =0 )#line:1222
        return #line:1224
    def CommandDesignPopup (OO0O00OO0O00OOOOO ,x =-1 ,y =-1 ):#line:1227
        if OO0O00OO0O00OOOOO ._dlgPopupDesign is not None :#line:1228
            OO0O00OO0O00OOOOO ._dlgPopupDesign .Close ()#line:1229
            OO0O00OO0O00OOOOO ._dlgPopupDesign =None #line:1230
        OO0O00OO0O00OOOOO ._dlgPopupDesign =DialogPopupDesign (OO0O00OO0O00OOOOO ._iconsPopupDesign ,initw =0 )#line:1232
        x ,y =AtMousePointer (OO0O00OO0O00OOOOO ,x ,y )#line:1234
        OO0O00OO0O00OOOOO ._dlgPopupDesign .Open (dlgtype =c4d .DLG_TYPE_ASYNC_POPUPEDIT ,pluginid =0 ,xpos =x ,ypos =y ,defaultw =0 ,defaulth =0 ,subid =0 )#line:1236
        return #line:1238
    def CommandCameraSwitch (OO0O0O00O000O00O0 ,OO0000O00OO00OOOO ):#line:1241
        O0000OOO000OOOO00 =c4d .documents .GetActiveDocument ()#line:1242
        O0OO0OO00OO00O0OO =GetDocBC (O0000OOO000OOOO00 )#line:1244
        O0O0O0O000000000O =CameraBCToList (O0OO0OO00OO00O0OO )#line:1246
        O0OO0O0OO00OO0OOO =O0O0O0O000000000O [OO0000O00OO00OOOO ][0 ]#line:1248
        O0O0O0OO0O000O0O0 =O0000OOO000OOOO00 .GetRenderBaseDraw ()#line:1250
        O0O0O0OO0O000O0O0 .SetSceneCamera (O0OO0O0OO00OO0OOO )#line:1252
        if OO0O0O00O000O00O0 ._cameraAttributes is not None :#line:1254
            OO0O0O00O000O00O0 ._cameraAttributes .SetObject (O0OO0O0OO00OO0OOO )#line:1255
        c4d .EventAdd ()#line:1257
        if ReadPrefValue (ID_PREF_POPUP_MODE ):#line:1259
            OO0O0O00O000O00O0 .Close ()#line:1260
    def CommandCameraQuickTab (O00OOOOO0OO0O0O0O ):#line:1263
        O0O0O000O00O0O0OO =GetDocBC ()#line:1264
        OOOOO0O0O00O00O00 =O0O0O000O00O0O0OO .GetInt32 (ID_DOC_NUM_CAMS )#line:1265
        for OOOOO0O0O0OO0OO00 in range (OOOOO0O0O00O00O00 ):#line:1267
            if not O00OOOOO0OO0O0O0O ._quickTabCameras .IsSelected (OOOOO0O0O0OO0OO00 ):#line:1268
                continue #line:1269
            O00OOOOO0OO0O0O0O .CommandCameraSwitch (OOOOO0O0O0OO0OO00 )#line:1271
            break #line:1273
    def CommandCameraThumbClick (OOOOOO0O0OOO00OOO ,OOOO00OO0O0000000 ):#line:1276
        O00O0O0O0000OO0O0 =MyTime ()#line:1277
        O0000O00000O00000 =False #line:1279
        O0O00000OO00000O0 =False #line:1280
        O0O00000O00O0OOOO =False #line:1281
        OO00OO0O000OOO0O0 =False #line:1282
        if (O00O0O0O0000OO0O0 -OOOOOO0O0OOO00OOO ._timeLastClick )<0.4 and OOOO00OO0O0000000 ==OOOOOO0O0OOO00OOO ._idxCamLastClick :#line:1284
            O0000O00000O00000 =True #line:1285
        OOOOOO0O0OOO00OOO ._timeLastClick =O00O0O0O0000OO0O0 #line:1287
        OOOOOO0O0OOO00OOO ._idxCamLastClick =OOOO00OO0O0000000 #line:1288
        O00OOOO000O0O0O00 =c4d .BaseContainer ()#line:1290
        if OOOOOO0O0OOO00OOO .GetInputState (c4d .BFM_INPUT_KEYBOARD ,c4d .BFM_INPUT ,O00OOOO000O0O0O00 ):#line:1291
            if O00OOOO000O0O0O00 [c4d .BFM_INPUT_QUALIFIER ]&0x03 ==0x03 :#line:1292
                OO00OO0O000OOO0O0 =True #line:1293
            elif O00OOOO000O0O0O00 [c4d .BFM_INPUT_QUALIFIER ]&0x01 :#line:1295
                O0O00000OO00000O0 =True #line:1296
            elif O00OOOO000O0O0O00 [c4d .BFM_INPUT_QUALIFIER ]&0x02 :#line:1298
                O0O00000O00O0OOOO =True #line:1299
        OO0O0000000OOOO0O =c4d .documents .GetActiveDocument ()#line:1301
        OO0OO0O000O0OO0OO =GetDocBC (OO0O0000000OOOO0O )#line:1303
        O0O00O0OO0O000OOO =CameraBCToList (OO0OO0O000O0OO0OO )#line:1305
        OOO0O0O00O000O0OO =O0O00O0OO0O000OOO [OOOO00OO0O0000000 ][0 ]#line:1307
        OOOOO0O0O00OOO0OO =O0O00O0OO0O000OOO [OOOO00OO0O0000000 ][4 ]#line:1308
        if (O0O00000O00O0OOOO or OO00OO0O000OOO0O0 or O0000O00000O00000 )and OOOOO0O0O00OOO0OO :#line:1310
            return #line:1311
        if O0000O00000O00000 :#line:1313
            CommandCameraOpenInAttributeManager (OO0O0000000OOOO0O ,OOO0O0O00O000O0OO )#line:1314
        elif O0O00000OO00000O0 :#line:1316
            OOOOOO0O0OOO00OOO .CommandThumbContextMenu (OOOO00OO0O0000000 )#line:1317
        elif O0O00000O00O0OOOO :#line:1319
            CommandCameraOpenInAttributeManager (OO0O0000000OOOO0O ,OOO0O0O00O000O0OO )#line:1320
        elif OO00OO0O000OOO0O0 :#line:1322
            CommandCameraDelete (OO0O0000000OOOO0O ,OOO0O0O00O000O0OO )#line:1323
        else :#line:1325
            OOOOOO0O0OOO00OOO .CommandCameraSwitch (OOOO00OO0O0000000 )#line:1326
    def CommandButtonCurrentCam (OOO0OOOOO0O00000O ):#line:1329
        O000O0O000OO0OO00 ,O000000O00O000O0O =GetActiveCamera ()#line:1330
        O000OO0O00OO0OO00 =GetDocBC ()#line:1332
        OO00O0OO0OO000000 =CameraBCToList (O000OO0O00OO0OO00 )#line:1334
        O000OOO0O000OO0O0 =GetCameraIndex (OO00O0OO0OO000000 ,O000O0O000OO0OO00 )#line:1336
        if O000OOO0O000OO0O0 is not None :#line:1338
            OOO0OOOOO0O00000O .CommandThumbContextMenu (O000OOO0O000OO0O0 )#line:1339
    def CommandAddThumbRenderSettings (O0OO00O0OO0000OO0 ):#line:1342
        OOOOOOO00O00OOO0O =c4d .documents .GetActiveDocument ()#line:1343
        CreateDefaultRenderDataImageRender (THUMB_RENDER_RESOLUTION [0 ],THUMB_RENDER_RESOLUTION [1 ],NAME_THUMB_RENDERDATA ,docToInsert =OOOOOOO00O00OOO0O ,alpha =True ,fast =True )#line:1345
        O0OO00O0OO0000OO0 .CommandRenderAllThumbnails ()#line:1347
        c4d .EventAdd ()#line:1349
    def CommandAddProofSheetRenderSettings (OO0OOO000000O0OOO ):#line:1352
        OO000OOOOOO0O00O0 =c4d .documents .GetActiveDocument ()#line:1353
        OOOO00OO0O0O0O0OO =OO000OOOOOO0O00O0 .GetActiveRenderData ()#line:1355
        CreateDefaultRenderDataImageRender (OOOO00OO0O0O0O0OO [c4d .RDATA_XRES ],OOOO00OO0O0O0O0OO [c4d .RDATA_YRES ],NAME_PROOF_SHEET_RENDERDATA ,docToInsert =OO000OOOOOO0O00O0 )#line:1357
        c4d .EventAdd ()#line:1359
    def CommandAddRenderAllRenderSettings (OO0O0O0O00O0OOO0O ):#line:1362
        O000OO0OO0O0OO0O0 =c4d .documents .GetActiveDocument ()#line:1363
        OO00OO000O0O00OO0 =O000OO0OO0O0OO0O0 .GetActiveRenderData ()#line:1365
        CreateDefaultRenderDataImageRender (OO00OO000O0O00OO0 [c4d .RDATA_XRES ],OO00OO000O0O00OO0 [c4d .RDATA_YRES ],NAME_RENDER_ALL_RENDERDATA ,docToInsert =O000OO0OO0O0OO0O0 )#line:1367
        c4d .EventAdd ()#line:1369
    def CommandEnableThumbs (OO0OO00O0000000O0 ,changePrefs =True ):#line:1373
        if changePrefs :#line:1374
            OOOO00OO0O00OO000 =TogglePrefValue (ID_PREF_THUMB_ENABLED )#line:1375
        else :#line:1377
            OOOO00OO0O00OO000 =ReadPrefValue (ID_PREF_THUMB_ENABLED )#line:1378
        if OOOO00OO0O00OO000 :#line:1380
            OO0OO00O0000000O0 .InitThumbnails ()#line:1381
        OO0OO00O0000000O0 .UpdateDesign ()#line:1383
    def CommandEnableCombo (O000OO0OO0OO0OO00 ,changePrefs =True ):#line:1386
        if changePrefs :#line:1387
            TogglePrefValue (ID_PREF_COMBO_ENABLED )#line:1388
        O000OO0OO0OO0OO00 .UpdateDesign ()#line:1390
    def CommandEnableTabs (O0O00O000OO0O00OO ,changePrefs =True ):#line:1393
        if changePrefs :#line:1394
            TogglePrefValue (ID_PREF_TABS_ENABLED )#line:1395
        O0O00O000OO0O00OO .UpdateDesign ()#line:1397
    def CommandThumbSize (OOO00O00O000OO000 ,thumbSize =None ):#line:1400
        if thumbSize is not None :#line:1401
            StorePrefValue (ID_PREF_THUMB_SIZE ,thumbSize )#line:1402
        OOO00O00O000OO000 .UpdateDesign ()#line:1404
        OOO00O00O000OO000 .UpdateThumbnails ()#line:1405
    def CommandToggleLayoutAttributes (OO00O00OOOO0OOOO0 ,changePrefs =True ):#line:1408
        O00OO000OOO0O00OO =ReadPrefValue (ID_PREF_SHOW_ATTRIBUTES )#line:1409
        if changePrefs :#line:1411
            O00OO000OOO0O00OO =(O00OO000OOO0O00OO +1 )%3 #line:1412
            StorePrefValue (ID_PREF_SHOW_ATTRIBUTES ,O00OO000OOO0O00OO )#line:1413
        OO00O00OOOO0OOOO0 ._bcWeights =GetDefaultWeightBC (O00OO000OOO0O00OO )#line:1415
        StorePrefValue (ID_PREF_WEIGHTS ,OO00O00OOOO0OOOO0 ._bcWeights )#line:1416
        OO00O00OOOO0OOOO0 .LayoutFlushGroup (ID_GROUP_MAIN_DIALOG )#line:1418
        OO00O00OOOO0OOOO0 .CreateLayoutGroupMain ()#line:1420
        OO00O00OOOO0OOOO0 .LayoutChanged (ID_GROUP_MAIN_DIALOG )#line:1422
        OO00O00OOOO0OOOO0 .UpdateDesign ()#line:1424
    def CommandNextCamera (O00OO0OO00000O0O0 ,previous =False ):#line:1427
        OOO00OO00000OOOO0 =c4d .documents .GetActiveDocument ()#line:1428
        if previous :#line:1430
            c4d .CallCommand (PLUGIN_ID_CAMS_COMMAND_PREV_CAM )#line:1431
        else :#line:1433
            c4d .CallCommand (PLUGIN_ID_CAMS_COMMAND_NEXT_CAM )#line:1434
    def CommandRenderAllThumbnails (O0OOO00O0O00O00OO ):#line:1438
        O0OOO00O0O00O00OO .InitThumbnails (forceRender =True )#line:1439
        O0OOO00O0O00O00OO .UpdateCameraChanged ()#line:1441
    def CommandAbout (O0O000OOOO0OO000O ):#line:1444
        O0OO0000OO0O00OOO =DialogAbout ()#line:1445
        O0OO0000OO0O00OOO .Open (c4d .DLG_TYPE_MODAL )#line:1446
    def CommandWelcome (OO000OOO0000OOOO0 ):#line:1449
        pass #line:1452
    def CommandOpenPreferences (O00000O00O0O000OO ):#line:1455
        if c4d .GetC4DVersion ()//1000 >=19 :#line:1456
            c4d .PrefsLib_OpenDialog (PLUGIN_ID_CAMS_PREFS )#line:1457
        else :#line:1459
            PrintError ('Cinema 4D below R19 not supported.')#line:1460
    def CreateLayout (O0O00O00OOO00OO00 ):#line:1463
        O0O00O00OOO00OO00 .SetTitle ('{0} {1}'.format (PLUGIN_NAME ,PLUGIN_VERSION ))#line:1464
        O0O00O00OOO00OO00 .CreateLayoutAddMenuCommandBar ()#line:1466
        if O0O00O00OOO00OO00 .GroupBegin (ID_GROUP_MAIN_DIALOG ,c4d .BFH_SCALEFIT |c4d .BFV_SCALEFIT ,cols =1 ):#line:1468
            O0O00O00OOO00OO00 .CreateLayoutGroupMain ()#line:1470
        O0O00O00OOO00OO00 .GroupEnd ()#line:1472
        O0O00O00OOO00OO00 .CreateLayoutAddMenu ()#line:1474
        O0O00O00OOO00OO00 .UpdateDesign ()#line:1476
        return True #line:1478
    def InitValues (O0000OOO0OO000OOO ):#line:1481
        O0000OOO0OO000OOO .InitThumbnails ()#line:1482
        O0000OOO0OO000OOO .CreateCamerasThumbnailGroup ()#line:1484
        O0000OOO0OO000OOO .UpdateCameraChanged ()#line:1486
        return True #line:1488
    def Restore (OO0O0O000OOOOOO00 ,OO00O0OOO0OO00O00 ,OOO00OOO00O00000O ):#line:1491
        OO0O0O000OOOOOO00 ._deferredRenderer .RestartRenderThread ()#line:1492
        return c4d .gui .GeDialog .Restore (OO0O0O000OOOOOO00 ,OO00O0OOO0OO00O00 ,OOO00OOO00O00000O )#line:1493
    _flagsTimerReason =0 #line:1496
    _iconBusyState =False #line:1497
    def Timer (OOOOO00O0OO0O0O00 ,OOOO0OOOO00OOOO00 ):#line:1498
        if not ReadPrefValue (ID_PREF_PLUGIN_ENABLED ):#line:1499
            OOOOO00O0OO0O0O00 .SetTimer (0 )#line:1500
            return #line:1501
        if OOOOO00O0OO0O0O00 ._flagsTimerReason &0x01 ==0x01 :#line:1503
            OOOOO00O0OO0O0O00 .CreateCamerasThumbnailGroup ()#line:1504
            OOOOO00O0OO0O0O00 ._flagsTimerReason =OOOOO00O0OO0O0O00 ._flagsTimerReason &0x02 #line:1505
        if OOOOO00O0OO0O0O00 ._flagsTimerReason &0x02 ==0x02 :#line:1507
            OOOOO00O0OO0O0O00 ._iconBusyState =not OOOOO00O0OO0O0O00 ._iconBusyState #line:1508
            if OOOOO00O0OO0O0O00 ._iconBusyState :#line:1509
                OOOOO00O0OO0O0O00 ._bitmapButtonCommandPanel .SetImage (OOOOO00O0OO0O0O00 ._bmpCommandPanelRenderBusy )#line:1510
            else :#line:1512
                OOOOO00O0OO0O0O00 ._bitmapButtonCommandPanel .SetImage (OOOOO00O0OO0O0O00 ._bmpCommandPanel )#line:1513
        if OOOOO00O0OO0O0O00 ._flagsTimerReason &0x02 ==0x00 :#line:1515
            OOOOO00O0OO0O0O00 ._bitmapButtonCommandPanel .SetImage (OOOOO00O0OO0O0O00 ._bmpCommandPanel )#line:1516
            OOOOO00O0OO0O0O00 ._iconBusyState =False #line:1517
            OOOOO00O0OO0O0O00 ._flagsTimerReason =0 #line:1518
            OOOOO00O0OO0O0O00 .SetTimer (0 )#line:1519
    def Message (OO0O000O0OOOO00OO ,OO00000OO0OOOO0O0 ,OOO00OO0O000O0O00 ):#line:1522
        O0OO00OO00O00O00O =OO00000OO0OOOO0O0 .GetId ()#line:1523
        if O0OO00OO00O00O00O ==c4d .BFM_SIZED :#line:1525
            OO0O000O0OOOO00OO .CreateCamerasThumbnailGroup ()#line:1526
        elif O0OO00OO00O00O00O ==c4d .BFM_LAYOUT_CHANGED :#line:1528
            OO0O000O0OOOO00OO .CreateCamerasThumbnailGroup ()#line:1529
        elif O0OO00OO00O00O00O ==c4d .BFM_ADJUSTSIZE :#line:1531
            OO0O000O0OOOO00OO .SetTimer (50 )#line:1533
        elif O0OO00OO00O00O00O ==c4d .BFM_WEIGHTS_CHANGED :#line:1535
            if OO00000OO0OOOO0O0 .GetInt32 (c4d .BFM_WEIGHTS_CHANGED )==ID_GROUP_CONTENT :#line:1536
                OO0O000O0OOOO00OO ._bcWeights =OO0O000O0OOOO00OO .GroupWeightsSave (ID_GROUP_CONTENT )#line:1537
                StorePrefValue (ID_PREF_WEIGHTS ,OO0O000O0OOOO00OO ._bcWeights )#line:1539
        return c4d .gui .GeDialog .Message (OO0O000O0OOOO00OO ,OO00000OO0OOOO0O0 ,OOO00OO0O000O0O00 )#line:1541
    def CoreMessage (O0O0O00OOOOO0OO00 ,O0O0OOO0O0O0OO000 ,O00OO0O0O0OO00O0O ):#line:1544
        if O0O0OOO0O0O0OO000 !=PLUGIN_ID_CAMS_COREMESSAGE :#line:1545
            return c4d .gui .GeDialog .CoreMessage (O0O0O00OOOOO0OO00 ,O0O0OOO0O0O0OO000 ,O00OO0O0O0OO00O0O )#line:1546
        O0000OOO0000O0OO0 =GetCoreMessageParam (O00OO0O0O0OO00O0O ,c4d .BFM_CORE_PAR1 )#line:1548
        if O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_CAMERA_LIST_CHANGE :#line:1550
            O0O0O00OOOOO0OO00 .CoreMessageCameraListChange ()#line:1551
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_CAMERA_ACTIVE_CHANGE :#line:1553
            O0O0O00OOOOO0OO00 .CoreMessageCameraActiveChange ()#line:1554
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_CHANGE_DESIGN :#line:1556
            O0O0O00OOOOO0OO00 .CoreMessageChangeDesign ()#line:1557
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_REDRAW_THUMBS :#line:1559
            O0O0O00OOOOO0OO00 .RedrawThumbnails ()#line:1560
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_RENDER_FINISHED_DLG_MAIN :#line:1562
            O0O0O00OOOOO0OO00 .CoreMessageReceiveRenderResult ()#line:1563
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_CHANGE_MENU_BUTTONS :#line:1565
            O0O0O00OOOOO0OO00 .CoreMessageChangeMenuButtons ()#line:1566
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_CLOSE_CAMS :#line:1568
            O0O0O00OOOOO0OO00 .CoreMessageCloseDialog ()#line:1569
        elif O0000OOO0000O0OO0 >=SUBID_COREMESSAGE_DLG_PER_CAM_BASE and O0000OOO0000O0OO0 <SUBID_COREMESSAGE_DLG_PER_CAM_BASE +1000000 :#line:1571
            O0O0O00OOOOO0OO00 .CoreMessageThumbPopupCommand (O0000OOO0000O0OO0 )#line:1572
        elif O0000OOO0000O0OO0 >=SUBID_COREMESSAGE_DLG_COMMAND_PANEL_BASE and O0000OOO0000O0OO0 <SUBID_COREMESSAGE_DLG_COMMAND_PANEL_BASE +1000000 :#line:1574
            O0O0O00OOOOO0OO00 .CoreMessageCommandPanelPopupCommand ()#line:1575
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_DESIGN_POPUP_COMMAND :#line:1577
            O0O0O00OOOOO0OO00 .CoreMessageDesignPopupCommand (keepOpen =True )#line:1578
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_DEFERRED_RENDER_BUSY :#line:1580
            O0O0O00OOOOO0OO00 ._flagsTimerReason |=0x02 #line:1581
            O0O0O00OOOOO0OO00 .SetTimer (250 )#line:1582
        elif O0000OOO0000O0OO0 ==SUBID_COREMESSAGE_DEFERRED_RENDER_IDLE :#line:1584
            O0O0O00OOOOO0OO00 ._flagsTimerReason =O0O0O00OOOOO0OO00 ._flagsTimerReason &0x01 #line:1585
        return c4d .gui .GeDialog .CoreMessage (O0O0O00OOOOO0OO00 ,O0O0OOO0O0O0OO000 ,O00OO0O0O0OO00O0O )#line:1587
    def AskClose (O0O00O000000O0OO0 ):#line:1590
        if O0O00O000000O0OO0 ._deferredRenderer is not None :#line:1591
            O0O00O000000O0OO0 ._deferredRenderer .StopRenderThread ()#line:1592
        return False #line:1594
    def Command (OOOOO000OO0OO000O ,OOOO000O0OOO00000 ,OOO0000O0O0O0O0O0 ):#line:1597
        if OOOO000O0OOO00000 >=ID_BASE_THUMBS and OOOO000O0OOO00000 <ID_BASE_THUMBS +20000 :#line:1598
            O00O000O0O000OOOO =OOOO000O0OOO00000 -ID_BASE_THUMBS #line:1599
            OOOOO000OO0OO000O .CommandCameraThumbClick (O00O000O0O000OOOO )#line:1600
        elif OOOO000O0OOO00000 >=ID_BASE_MENU_CAMERAS and OOOO000O0OOO00000 <ID_BASE_MENU_CAMERAS +20000 :#line:1602
            O00O000O0O000OOOO =OOOO000O0OOO00000 -ID_BASE_MENU_CAMERAS #line:1603
            OOOOO000OO0OO000O .CommandCameraSwitch (O00O000O0O000OOOO )#line:1604
        elif OOOO000O0OOO00000 ==ID_COMBO_CAMERAS :#line:1606
            O00O000O0O000OOOO =OOOOO000OO0OO000O .GetInt32 (OOOO000O0OOO00000 )#line:1607
            OOOOO000OO0OO000O .CommandCameraSwitch (O00O000O0O000OOOO )#line:1608
        elif OOOO000O0OOO00000 ==ID_QUICKTAB_CAMERAS :#line:1610
            OOOOO000OO0OO000O .CommandCameraQuickTab ()#line:1611
        elif OOOO000O0OOO00000 ==ID_CALL_PREFERENCES :#line:1613
            OOOOO000OO0OO000O .CommandOpenPreferences ()#line:1614
        elif OOOO000O0OOO00000 ==ID_CALL_ABOUT :#line:1616
            OOOOO000OO0OO000O .CommandAbout ()#line:1617
        elif OOOO000O0OOO00000 ==ID_CALL_WELCOME :#line:1619
            OOOOO000OO0OO000O .CommandWelcome ()#line:1620
        elif OOOO000O0OOO00000 ==ID_UPDATE_CURRENT_THUMB :#line:1622
            OOOOO000OO0OO000O .CommandUpdateCurrentThumb (force =True )#line:1623
        elif OOOO000O0OOO00000 ==ID_ADD_THUMB_RENDER_SETTINGS :#line:1625
            OOOOO000OO0OO000O .CommandAddThumbRenderSettings ()#line:1626
        elif OOOO000O0OOO00000 ==ID_ADD_PROOF_SHEET_RENDER_SETTINGS :#line:1628
            OOOOO000OO0OO000O .CommandAddProofSheetRenderSettings ()#line:1629
        elif OOOO000O0OOO00000 ==ID_ADD_THUMB_RENDER_SETTINGS :#line:1631
            OOOOO000OO0OO000O .CommandAddRenderAllRenderSettings ()#line:1632
        elif OOOO000O0OOO00000 ==ID_BITMAPBUTTON_ENABLE_COMBO :#line:1634
            OOOOO000OO0OO000O .CommandEnableCombo ()#line:1635
        elif OOOO000O0OOO00000 ==ID_BITMAPBUTTON_ENABLE_TABS :#line:1637
            OOOOO000OO0OO000O .CommandEnableTabs ()#line:1638
        elif OOOO000O0OOO00000 ==ID_BITMAPBUTTON_ENABLE_THUMBS :#line:1640
            OOOOO000OO0OO000O .CommandEnableThumbs ()#line:1641
        elif OOOO000O0OOO00000 ==ID_BITMAPBUTTON_POPUP_DESIGN :#line:1643
            OOOOO000OO0OO000O .CommandDesignPopup ()#line:1644
        elif OOOO000O0OOO00000 ==ID_BUTTON_PREV_CAM :#line:1646
            OOOOO000OO0OO000O .CommandNextCamera (previous =True )#line:1647
        elif OOOO000O0OOO00000 ==ID_BUTTON_NEXT_CAM :#line:1649
            OOOOO000OO0OO000O .CommandNextCamera ()#line:1650
        elif OOOO000O0OOO00000 ==ID_RENDER_ALL_THUMBS or OOOO000O0OOO00000 ==ID_BUTTON_UPDATE_ALL_THUMBS :#line:1652
            OOOOO000OO0OO000O .CommandRenderAllThumbnails ()#line:1653
        elif OOOO000O0OOO00000 ==ID_RENDER_ALL_TO_PV or OOOO000O0OOO00000 ==ID_RENDER_ALL_TO_PV_VP or OOOO000O0OOO00000 ==ID_RENDER_ALL_TO_PV_CURRENT_RD or OOOO000O0OOO00000 ==ID_RENDER_PROOF_SHEET or OOOO000O0OOO00000 ==ID_RENDER_PROOF_SHEET_VP or OOOO000O0OOO00000 ==ID_RENDER_PROOF_SHEET_CURRENT_RD :#line:1656
            OOOOO000OO0OO000O .CommandRenderAllCameras (OOOO000O0OOO00000 )#line:1657
        elif OOOO000O0OOO00000 >=ID_CREATE_CAMERA_STANDARD and OOOO000O0OOO00000 <=ID_CREATE_CAMERA_STANDARD +999 :#line:1659
            CommandCreateCamera (OOOO000O0OOO00000 )#line:1660
        elif OOOO000O0OOO00000 >=ID_EDITOR_VISIBILITY_ALL_DEFAULT and OOOO000O0OOO00000 <=ID_RENDER_VISIBILITY_ALL_OFF :#line:1662
            CommandVisibilityAll (OOOO000O0OOO00000 )#line:1663
        elif OOOO000O0OOO00000 >=ID_MENU_THUMB_SIZE_SMALL and OOOO000O0OOO00000 <=ID_MENU_THUMB_SIZE_LARGE :#line:1665
            OOO0O0O0O00OOOO00 =OOOO000O0OOO00000 -ID_MENU_THUMB_SIZE_SMALL #line:1666
            OOOOO000OO0OO000O .CommandThumbSize (OOO0O0O0O00OOOO00 )#line:1667
        elif OOOO000O0OOO00000 ==ID_BUTTON_ALL_CAMS_POPUP :#line:1669
            OOOOO000OO0OO000O .CommandCommandPanelPopup ()#line:1670
        elif OOOO000O0OOO00000 ==ID_BUTTON_CURRENT_CAM :#line:1672
            OOOOO000OO0OO000O .CommandButtonCurrentCam ()#line:1673
        elif OOOO000O0OOO00000 ==92 :#line:1675
            pass #line:1676
        else :#line:1678
            PrintError ("UNKNOWN COMMAND. Click! Did you hear this? A developer's soul has vanished.")#line:1679
        return True #line:1681
