import c4d
# NO CUSTOM MODULE IMPORTS HERE!!!


ID_GROUP_MAIN_DIALOG                 = 1000
ID_GROUP_DESIGN_COMBO                = 1001
ID_GROUP_DESIGN_TABS                 = 1002
ID_GROUP_DESIGN_THUMBS               = 1003
ID_SCROLLGROUP_CAMERAS               = 1005
ID_GROUP_CONTENT_SCROLLGROUP_CAMERAS = 1006
ID_GROUP_CAMERAS_THUMBNAIL_COLUMNS   = 1007
ID_GROUP_CONTENT                     = 1008

ID_CALL_PREFERENCES                  = 2000
ID_COMBO_CAMERAS                     = 2001
ID_QUICKTAB_CAMERAS                  = 2002
ID_BITMAPBUTTON_PREFS                = 2003
ID_CALL_ABOUT                        = 2004
ID_UPDATE_CURRENT_THUMB              = 2005
ID_ADD_THUMB_RENDER_SETTINGS         = 2008
ID_ADD_PROOF_SHEET_RENDER_SETTINGS   = 2009
ID_ADD_RENDER_ALL_RENDER_SETTINGS    = 2010
ID_BITMAPBUTTON_ENABLE_THUMBS        = 2011
ID_BITMAPBUTTON_ENABLE_COMBO         = 2012
ID_BITMAPBUTTON_ENABLE_TABS          = 2013
ID_BITMAPBUTTON_THUMB_SIZE           = 2014
ID_BUTTON_NEXT_CAM                   = 2015
ID_BUTTON_PREV_CAM                   = 2016
ID_BITMAPBUTTON_TOGGLE_ATTRIBUTES    = 2017
ID_RENDER_ALL_THUMBS                 = 2018
ID_CALL_WELCOME                      = 2019
ID_RENDER_PROOF_SHEET                = 2020
ID_RENDER_ALL_TO_PV                  = 2021
ID_BUTTON_UPDATE_ALL_THUMBS          = 2022
ID_RENDER_ALL_TO_PV_VP               = 2023
ID_RENDER_ALL_TO_PV_CURRENT_RD       = 2024
ID_RENDER_PROOF_SHEET_VP             = 2025
ID_RENDER_PROOF_SHEET_CURRENT_RD     = 2026
ID_BUTTON_ALL_CAMS_POPUP             = 2027
ID_BUTTON_CURRENT_CAM                = 2028
ID_BITMAPBUTTON_POPUP_DESIGN         = 2029

ID_EDITOR_VISIBILITY_ALL_DEFAULT     = 2040
ID_EDITOR_VISIBILITY_ALL_ON          = 2041
ID_EDITOR_VISIBILITY_ALL_OFF         = 2042
ID_RENDER_VISIBILITY_ALL_DEFAULT     = 2043
ID_RENDER_VISIBILITY_ALL_ON          = 2044
ID_RENDER_VISIBILITY_ALL_OFF         = 2045

ID_CAMERA_ATTRIBUTES                 = 2050

ID_MENU_THUMB_SIZE_SMALL             = 2060
ID_MENU_THUMB_SIZE_MEDIUM            = 2061
ID_MENU_THUMB_SIZE_LARGE             = 2062

ID_CREATE_CAMERA_STANDARD            = 2100
ID_CREATE_CAMERA_TARGET              = 2101
ID_CREATE_CAMERA_MOTION              = 2102
ID_CREATE_CAMERA_STEREO              = 2103
ID_CREATE_CAMERA_CRANE               = 2104

ID_CREATE_CAMERA_PREVIEW             = 2105
ID_CREATE_CAMERA_PREVIEW_INSIDEOUT   = 2106

ID_CREATE_CAMERA_RS_STANDARD         = 2110
ID_CREATE_CAMERA_RS_FISHEYE          = 2111
ID_CREATE_CAMERA_RS_SPHERICAL        = 2112
ID_CREATE_CAMERA_RS_CYLINDRICAL      = 2113
ID_CREATE_CAMERA_RS_STEREO_SPHERICAL = 2114
ID_CREATE_CAMERA_CO_STANDARD         = 2120
ID_CREATE_CAMERA_OC_STANDARD         = 2130
ID_CREATE_CAMERA_VR_PHYSICAL         = 2140

ID_BASE_MENU_CAMERAS                 = 10000

ID_BASE_THUMBS                       = 100000


ID_POPUP_MENU__MUTE_BUTTON        = c4d.FIRST_POPUP_ID + 0

ID_THUMB_MENU_ACTIVATE            = c4d.FIRST_POPUP_ID + 1
ID_THUMB_MENU_OPEN_IN_AM          = c4d.FIRST_POPUP_ID + 2

ID_THUMB_MENU_VIS_EDITOR_SUBMENU  = c4d.FIRST_POPUP_ID + 3
ID_THUMB_MENU_VIS_EDITOR_ON       = c4d.FIRST_POPUP_ID + 300
ID_THUMB_MENU_VIS_EDITOR_OFF      = c4d.FIRST_POPUP_ID + 301
ID_THUMB_MENU_VIS_EDITOR_DEFAULT  = c4d.FIRST_POPUP_ID + 302

ID_THUMB_MENU_VIS_RENDER_SUBMENU  = c4d.FIRST_POPUP_ID + 4
ID_THUMB_MENU_VIS_RENDER_ON       = c4d.FIRST_POPUP_ID + 400
ID_THUMB_MENU_VIS_RENDER_OFF      = c4d.FIRST_POPUP_ID + 401
ID_THUMB_MENU_VIS_RENDER_DEFAULT  = c4d.FIRST_POPUP_ID + 402

ID_THUMB_MENU_UPDATE              = c4d.FIRST_POPUP_ID + 5
ID_THUMB_MENU_DELETE              = c4d.FIRST_POPUP_ID + 6
ID_THUMB_MENU_RENDER              = c4d.FIRST_POPUP_ID + 7
ID_THUMB_MENU_RENDER_VP           = c4d.FIRST_POPUP_ID + 8
ID_THUMB_MENU_RENDER_CURENT_RD    = c4d.FIRST_POPUP_ID + 9

ID_THUMB_MENU_OPEN_TAG_IN_AM_BASE = c4d.FIRST_POPUP_ID + 500


ID_ICON_ATTRIBUTES_DONT_SHOW    = 465001731 # Show Right Part PV
ID_ICON_ATTRIBUTES_SHOW_BOTTOM  = 465001732 # Hide Right Part PV
ID_ICON_ATTRIBUTES_SHOW_RIGHT   = 465001796 # Hide RQ Bottom

# 13858: Next Project, 1025779: Next Day, 13857: Previous Project, 1025781 Previous day
if c4d.GetC4DVersion() // 1000 >= 25:
    ID_ICON_PREV_CAMERA             = 300000126 # AM Left
    ID_ICON_NEXT_CAMERA             = 300000127 # AM Right

else:
    ID_ICON_PREV_CAMERA             = 1025781 # Previous day
    ID_ICON_NEXT_CAMERA             = 1025779 # Next Day

ID_ICON_UPDATE_ALL_THUMBS       = 13565

ID_ICON_COMMAND_RENDER            = 13931 # Use as Render View
ID_ICON_COMMAND_RENDER_VP         = 12162 # Render Active Objects
ID_ICON_COMMAND_RENDER_CURRENT_RD = 12099 # Render to Picture Viewer

ID_ICON_ATTRIBUTE_MANAGER       = 1000468 # Attribute Manager

ID_ICON_VISIBILITY_DEFAULT      = c4d.RESOURCEIMAGE_OBJECTMANAGER_DOT3
ID_ICON_VISIBILITY_ON           = c4d.RESOURCEIMAGE_OBJECTMANAGER_DOT1
ID_ICON_VISIBILITY_OFF          = c4d.RESOURCEIMAGE_OBJECTMANAGER_DOT2

ID_ICON_DELETE                  = 12109 # Delete

ID_ICON_CAM_ANIMATED            = 12412 # Play Forward

ID_ICON_ALL_CAMS                = 12100 # Camera
ID_ICON_CURRENT_CAM             = 5103 # Camera

ID_ICON_CAMERA_STANDARD         = 5103 # Camera
ID_ICON_CAMERA_TARGET           = 5676 # Target Expression Tag
ID_ICON_CAMERA_MOTION           = 1027744 # Motion Camera
ID_ICON_CAMERA_STEREO           = 450000256 # Stereo Camera
ID_ICON_CAMERA_CRANE            = 1028271 # Camera Crane

if c4d.GetC4DVersion() // 1000 >= 21:
    ID_ICON_PREFS               = 1026694  # Settings off Icon ID # TODO Andreas: symbol?
    ID_ICON_TABS_ON             = c4d.RESOURCEIMAGE_LAYERMANAGER_STATE3
    ID_ICON_TABS_OFF            = c4d.RESOURCEIMAGE_LAYERMANAGER_STATE4

    ID_ICON_RENDER_BUSY         = 440000299

else:
    ID_ICON_PREFS               = 1026693  # Settings Icon ID # TODO Andreas: symbol?
    ID_ICON_TABS_ON             = 465001796
    ID_ICON_TABS_OFF            = 465001732

    ID_ICON_RENDER_BUSY         = 431000005
